<?php
$desktop_model					= array();
$tablet_model						= array();
$mobile_model					= array();
$desktop_model['version']		= "1.0.0";

// Board Model
$desktop_model['list']		= '
{"type":"list_check","width":"50px","level":"10","class":"list_check"},
{"field":"fn_pid","name":"W_PID","width":"50px","type":"pid","class":"mb-pid","responsive":"mb-hide-mobile mb-hide-tablet"},
{"field":"fn_title","name":"상품/옵션정보","width":"","mobile_width":"240px","type":"commerce_title_description_icon_status","maxlength":"100","maxtext":"..","td_class":"text-left","order":"false","search":"false"},
{"field":"fn_title","name":"강의명","type":"search"},
{"field":"fn_product_description","name":"상품설명","type":"search"},
{"field":"fn_sale_count","name":"신청","width":"40px","search":"false","class":"hit","responsive":"mb-hide-mobile mb-hide-tablet"},
{"field":"fn_hit","name":"조회","width":"40px","class":"hit","search":"false","responsive":"mb-hide-mobile mb-hide-tablet"},
{"field":"fn_stock","name":"인원","width":"40px","class":"hit","search":"false","responsive":"mb-hide-mobile mb-hide-tablet"},
{"field":"fn_sale_price","name":"판매금액","type":"commerce_product_price","width":"90px","order":"false","responsive":"mb-hide-mobile"},
{"field":"fn_user_name","name":"모집상태","width":"100px","type":"commerce_name","responsive":"mb-hide-mobile mb-hide-tablet","order":"false","display_check":"equal:commerce_lecture_status_list:lecture:fn_product_type"},
';

$desktop_model['list_admin']		= '
{"type":"list_check","width":"50px","mobile_width":"30px","level":"10","class":"list_check"},
{"field":"fn_pid","name":"W_PID","width":"50px","type":"pid","class":"mb-pid","responsive":"mb-hide-mobile mb-hide-tablet"},
{"field":"fn_title","name":"상품/옵션정보","width":"","mobile_width":"240px","type":"commerce_title_description_icon_status","maxlength":"100","maxtext":"..","td_class":"text-left","order":"false","search":"false"},
{"field":"fn_title","name":"강의명","type":"search"},
{"field":"fn_product_description","name":"상품설명","type":"search"},
{"field":"fn_sale_count","name":"신청","width":"40px","search":"false","class":"hit","responsive":"mb-hide-mobile mb-hide-tablet"},
{"field":"fn_hit","name":"조회","width":"40px","class":"hit","search":"false","responsive":"mb-hide-mobile mb-hide-tablet"},
{"field":"fn_stock","name":"인원","width":"40px","class":"hit","search":"false","responsive":"mb-hide-mobile mb-hide-tablet"},
{"field":"fn_sale_price","name":"판매금액","type":"commerce_product_price","width":"90px","order":"false","responsive":"mb-hide-mobile"},
{"field":"fn_user_name","name":"모집상태","width":"100px","type":"commerce_name","responsive":"mb-hide-mobile mb-hide-tablet","order":"false","display_check":"equal:commerce_lecture_status_list:lecture:fn_product_type"},
{"name":"판매구분","width":"90px","type":"commerce_btn_list_product_admin","class":"commerce_btn_list_product_admin"},
';

$desktop_model['list_gallery']		= '
{"field":"fn_image_path","name":"이미지","width":"50px","height":"50px","type":"img_ratio","class":"img","td_class":"img-border","link":"view"},
{"field":"fn_title","name":"제목","width":"","type":"commerce_title_product","maxlength":"10","maxtext":"..","td_class":"text-left"},
{"field":"fn_reg_date","name":"날짜","width":"115px","type":"gallery_date","td_class":"date"},
{"field":"fn_user_name","name":"작성자","width":"115px","td_class":"name"}
';
$desktop_model['list_calendar']		= '
{"field":"fn_title","name":"제목","width":"","type":"title","maxlength":"8","maxtext":"..","td_class":"text-left"}
';

$add_email_attribute1		= '"display_check":"login:hide",';
if(mbw_get_option("commerce_item_type")=="open_market"){
	$add_email_attribute1		= '';
}
//글작성 스킨 수정
$desktop_model['write']		= '
{"tpl":"tag","tag_name":"table","type":"start","name":"글쓰기","width":"20%,*","mobile_width":"80px,*","class":"table table-write"},
{"field":"fn_category1","name":"카테고리","width":"100px","type":"category1","class":"category"},
{"field":"fn_user_name","name":"작성자","width":"150px","maxlength":"20","display_check":"login:none","required":"(*)","class":"user_name"},
{"field":"fn_passwd","name":"비밀번호","width":"150px","display_check":"login:hide","maxlength":"16","type":"password","required":"(*)","class":"passwd"},
{"field":"fn_title","name":"강의명","width":"99%","required":"(*)","class":"text-left","required_error":"MSG_FIELD_EMPTY_ERROR2"},
{"field":"fn_user_email","name":"이메일","width":"99%",'.$add_email_attribute1.'"type":"commerce_user_email"},
{"field":"fn_regular_price","name":"강의 가격","width":"200px","maxlength":"10","class":"mbi-only-int","required":"(*)","default":"10000","description":"<br>강의의 정상가격을 입력합니다"},
{"field":"fn_sale_price","name":"판매 가격","width":"200px","maxlength":"10","class":"mbi-only-int","required":"(*)","default":"10000","description":"<br>강의의 할인된 가격이 적용된 판매가격을 입력합니다"},
{"field":"fn_sale_text","name":"할인율 표시","width":"200px","description":"<br>강의의 할인율 표시를 직접 입력합니다. (생략시 자동으로 계산되어 표시됩니다)"},
{"field":"fn_product_point","name":"적립 포인트","width":"200px","maxlength":"10","class":"mbi-only-int","default":"0"},
{"field":"fn_sale_status","name":"판매구분","width":"200px","type":"radio","data":"0,1,2","label":"준비중,모집중,모집마감","default":"1"},
{"field":"fn_is_show","name":"상품전시","width":"200px","type":"radio","data":"0,1","label":"전시안함,상품전시","default":"1","description":"<br>판매목록 전시 여부를 설정합니다."},
{"field":"fn_product_description","name":"요약설명","width":"99%","type":"textarea"},
{"field":"fn_file1","name":"대표이미지","width":"200px","type":"file_image","class":"file","sequence":"number","required":"(*)","required_error":"MSG_FILE_EMPTY_ERROR1"},
{"field":"fn_file2","name":"이미지1","width":"200px","type":"file_image","class":"file","sequence":"number"},
{"field":"fn_file3","name":"이미지2","width":"200px","type":"file_image","class":"file","sequence":"number"},
{"field":"fn_file4","name":"이미지3","width":"200px","type":"file_image","class":"file","sequence":"number"},
{"field":"fn_site_link1","name":"교체 이미지","width":"200px","type":"file_singular_upload","description":"<br>(상품 목록에서 대표 이미지를 2~8초간격으로 교체해줄 이미지를 등록합니다)"},
{"field":"fn_site_link2","name":"오버 이미지","width":"200px","type":"file_singular_upload","description":"<br>(상품 목록에서 대표 이미지에 마우스 오버시 표시할 이미지를 등록합니다)"},
{"field":"fn_product_type","name":"상품타입","width":"200px","display":"hide","default":"lecture"},
{"field":"fn_pay_type","name":"결제방식","width":"200px","type":"checkbox2","data":"card,d_bank,handphone,v_bank,bank,paypal","label":"신용카드,실시간 계좌이체,핸드폰결제,가상계좌,무통장입금,페이팔","default":"0","description":"<br>(특정 상품에만 결제방식을 다르게 적용하기 위한 기능으로 결제방식을 다르게 설정할 경우 장바구니 기능과 포인트 사용을 사용할 수 없습니다)"},
{"field":"fn_content","name":"내용","width":"100%","type":"content","class":"content","colspan":"2","td_class":"content-box","required_error":"MSG_FIELD_EMPTY_ERROR2"},
{"field":"fn_tag","name":"태그","width":"99%","class":"tag","description":"<br>(태그는 쉼표로 구분해서 입력해 주세요)"},
{"field":"fn_template_name","name":"템플릿 이름","width":"250px","type":"commerce_product_view_template_list","default":"view-basic1"},
{"field":"fn_template_type","name":"템플릿 타입","width":"250px","type":"commerce_product_view_template_type","description":"<br> - TAB-4 : 상품정보/상품리뷰/상품Q&A/교환정보 탭메뉴로 표시<br> - CONTENT-1 : 콘텐츠 내용만 표시<br> - CONTENT-COMMENT : 콘텐츠 내용, 댓글 기능 표시)"},
{"field":"fn_product_icon1","name":"강의 아이콘1","width":"250px","type":"commerce_product_icon_select"},
{"field":"fn_product_icon2","name":"강의 아이콘2","width":"250px","type":"commerce_product_icon_select"},
{"field":"fn_use_product_options","name":"주문 옵션","width":"60px","type":"radio","td_style":"overflow: visible !important;","data":"0,1,2","label":"사용안함,일반옵션,재고옵션","default":"0","combo":[{"type":"commerce_product_add_op01","match_value":"1","parent_style":"padding-top:5px;"},{"type":"commerce_product_add_op02","match_value":"2","parent_style":"padding-top:5px;"}],"description":"<br>(상품 주문시에 필요한 필수,선택 옵션을 설정합니다)"},
{"field":"fn_lecturer","name":"강사","width":"99%"},
{"field":"fn_lecture_place","name":"장소","width":"99%"},
{"field":"fn_lecture_date","name":"날짜","width":"99%"},
{"field":"fn_lecture_deadline","name":"모집 마감일","width":"200px","type":"text_calendar","class":"show-datepicker","style":"text-align:left;","substr":"10","attribute":" readonly"},
{"field":"fn_stock","name":"모집인원","width":"200px","type":"number","default":"20","description":"<br>최대 모집인원을 설정합니다"},
{"field":"fn_sale_count","name":"현재 신청인원","width":"200px","default":"0","type":"number","write":"none","reply":"none","description":"<br>현재까지 신청한 인원수를 설정합니다 (강의 신청시 자동으로 1씩 증가하고, 취소시에 1씩 감소하며 모집인원과 동일할 경우 자동으로 모집이 마감됩니다)"},
{"field":"fn_product_rank1","name":"검색 우선순위","width":"200px","default":"0","description":"<br>(검색 우선순위가 높을 수록 상품 목록 상위에 표시됩니다)"},
{"field":"fn_product_memo","name":"상품메모","width":"99%","description":"<br>(상품 관리에 필요한 주의사항 및 특이사항을 입력합니다)"},
{"type":"kcaptcha_img","name":"자동등록방지","width":"70px","height":"30px","class":"kcaptcha","level":{"sign":"<","grade":"1"},"modify":"none","description":"<br>(자동등록방지 숫자를 순서대로 입력해 주세요)"},
{"tpl":"tag","tag_name":"table","type":"end"}
';


// Comment Model
$desktop_model['comment_list']		= '
{"field":"fn_user_name","name":"작성자","width":"100px","class":"cmt-name","type":"cl_name_date"},
{"field":"fn_content","name":"내용","width":"60px","type":"content","class":"cmt-content","type":"cl_content"}
';

$desktop_model['comment_write']		= '
{"tpl":"tag","tag_name":"table","type":"start","name":"댓글","width":"20%,*","mobile_width":"80px,*","class":"table table-comment"},
{"field":"fn_user_name","name":"작성자","width":"100px","login":"cw_name","required":"(*)","class":"user_name"},
{"field":"fn_passwd","name":"비밀번호","width":"100px","login":"none","type":"password","required":"(*)","class":"passwd"},
{"type":"kcaptcha_img","name":"자동등록방지","width":"70px","height":"30px","class":"kcaptcha","level":{"sign":"<","grade":"1"},"modify":"none","description":"<br>(자동등록방지 숫자를 순서대로 입력해 주세요)"},
{"field":"fn_content","name":"내용","width":"100%","type":"cw_content","required":"(*)","class":"comment","required_error":"MSG_FIELD_EMPTY_ERROR2"},
{"tpl":"tag","tag_name":"table","type":"end"}
';
$desktop_model['comment_reply']	= $desktop_model['comment_write'];


// Tablet Model
$tablet_model					= $desktop_model;

// Mobile Model
$mobile_model				= $desktop_model;



//Filter 사용방법 : 필터에 등록된 단어가 포함되어 있을 경우 에러 출력 (관리자 레벨 이하인 회원에게만 적용)
//{"field":"fn_title","name":"제목","width":"100px","type":"title","required":"(*)","filter":"filter_swear","filter_error":"금지어가 포함되어 있습니다"},
mbw_set_filter("filter_swear","18아,18놈,18새끼,18년,18뇬,18노,18것,18넘,개년,개놈,개뇬,개새,개색끼,개세끼,개세이,개쉐이,개쉑,개쉽,개시키,개자식,개좆,게색기,게색끼,광뇬,뇬,눈깔,뉘미럴,니귀미,니기미,니미,도촬,되질래,뒈져라,뒈진다,디져라,디진다,디질래,병쉰,병신,뻐큐,뻑큐,뽁큐,삐리넷,새꺄,쉬발,쉬밸,쉬팔,쉽알,스패킹,스팽,시벌,시부랄,시부럴,시부리,시불,시브랄,시팍,시팔,시펄,실밸,십8,십쌔,십창,싶알,쌉년,썅놈,쌔끼,쌩쑈,썅,써벌,썩을년,쎄꺄,쎄엑,쓰바,쓰발,쓰벌,쓰팔,씨8,씨댕,씨바,씨발,씨뱅,씨봉알,씨부랄,씨부럴,씨부렁,씨부리,씨불,씨브랄,씨빠,씨빨,씨뽀랄,씨팍,씨팔,씨펄,씹,아가리,아갈이,엄창,접년,잡놈,재랄,저주글,조까,조빠,조쟁이,조지냐,조진다,조질래,존나,존니,좀물,좁년,좃,좆,좇,쥐랄,쥐롤,쥬디,지랄,지럴,지롤,지미랄,쫍빱,凸,퍽큐,뻑큐,빠큐,ㅅㅂㄹㅁ");
mbw_set_filter("filter_admin","admin,administrator,관리자,운영자");

//Pattern 사용방법 : 입력된 데이타가 요구 패턴에 맞지 않으면 에러 출력 ("required":"(*)" 가 설정된 항목에만 적용됨)
//{"field":"fn_title","name":"제목","width":"100px","type":"title","required":"(*)","pattern":"email","pattern_error":"정상적인 이메일 주소가 아닙니다"
mbw_set_pattern("email","/^[^@.]{4,}@[0-9a-z-.]{3,}$/");


//Unique 사용방법 : 입력된 데이타가 디비에 존재하면 에러 출력 ("required":"(*)" 가 설정된 항목에만 적용됨)
//{"field":"fn_title","name":"제목","width":"100px","type":"title","required":"(*)","unique":"","unique_error":"이미 존재하는 이름입니다<br>다른 이름을 입력해 주세요"


mbw_set_fields("select_board",$mb_fields["commerce_product"]);


if(!function_exists('mbw_board_product_api_body')){
	function mbw_board_product_api_body(){
		
	}
}
add_action('mbw_board_api_body', 'mbw_board_product_api_body',5); 


if(!function_exists('mbw_commerce_product_option_filter')){
	function mbw_commerce_product_option_filter( $data ) {
		$options										= array();
		$required_options						= array();
		$add_options								= array();

		if(mbw_get_param("use_product_options")=="1"){

			$required_options["title"]				= mbw_get_param("product_required_options_select_title");
			$required_options["value"]				= mbw_get_param("product_required_options_select_value");
			$required_options["price"]				= mbw_get_param("product_required_options_select_price");

			for($i=0;$i<count($required_options["value"]);$i++){
				if(!empty($required_options["value"][$i])){
					$options["required_options"]["title"][]			= $required_options["title"][$i];
					$options["required_options"]["value"][]		= $required_options["value"][$i];
					$options["required_options"]["price"][]			= $required_options["price"][$i];
				}
			}
			$data['product_options_type']		= 'mc-op01';

			$add_options["title"]						= mbw_get_param("product_add_options_select_title");
			$add_options["value"]					= mbw_get_param("product_add_options_select_value");
			$add_options["price"]					= mbw_get_param("product_add_options_select_price");

			for($i=0;$i<count($add_options["value"]);$i++){
				if(!empty($add_options["value"][$i])){
					$options["add_options"]["title"][]			= $add_options["title"][$i];
					$options["add_options"]["value"][]		= $add_options["value"][$i];
					$options["add_options"]["price"][]			= $add_options["price"][$i];
				}
			}

		}else if(mbw_get_param("use_product_options")=="2"){
			$options["required_options2"]		= mbw_get_param("mc-op2-output");
			$order_options							= json_decode($options["required_options2"],true);
			$item_name								= mbw_get_options_name($order_options);
			$item_count								= mbw_get_options_count($order_options);
			ksort($item_name);
			ksort($item_count);
			mbw_set_vars("op02_name",$item_name);
			mbw_set_vars("op02_count",$item_count);

			$required_options["title"]				= mbw_get_param("product_required_options_select_title2");

			for($i=0;$i<count($required_options["title"]);$i++){
				if(!empty($required_options["title"])){
					$options["required_options2_title"]["title"][]			= $required_options["title"][$i];
				}
			}

			$data['product_options_type']		= 'mc-op02';

			$add_options["title"]						= mbw_get_param("product_add_options_select_title2");
			$add_options["value"]					= mbw_get_param("product_add_options_select_value2");
			$add_options["price"]					= mbw_get_param("product_add_options_select_price2");

			for($i=0;$i<count($add_options["value"]);$i++){
				if(!empty($add_options["value"][$i])){
					$options["add_options2"]["title"][]			= $add_options["title"][$i];
					$options["add_options2"]["value"][]			= $add_options["value"][$i];
					$options["add_options2"]["price"][]			= $add_options["price"][$i];
				}
			}
		}

		$data["product_options"]				= serialize($options);
		return $data;
	}
}

if(!function_exists('mbw_board_product_api_footer')){
	function mbw_board_product_api_footer(){
		if((mbw_get_param("board_name")=="commerce_product" || mbw_get_param("board_name")=="commerce_lecture") && mbw_get_param("mode")=="write"){

			if(mbw_get_param("use_product_options")=="2"){
				global $mb_fields,$mdb,$mb_admin_tables;
				$fields				= $mb_fields["meta"];
				$board_pid			= intval(mbw_get_param("board_pid"));

				//meta 테이블 디비 삭제
				$mdb->query($mdb->prepare("DELETE FROM ".$mb_admin_tables["meta"]." WHERE ".$mb_fields["meta"]["fn_meta_pid"]."=%s AND (".$mb_fields["meta"]["fn_meta_table"]."='commerce_product_op02_name' OR ".$mb_fields["meta"]["fn_meta_table"]."='commerce_product_op02_count')",$board_pid));

				$options_name		= mbw_get_vars("op02_name");
				$options_count		= mbw_get_vars("op02_count");
				if(!empty($options_count)){			
					//meta 테이블 디비 입력
					$insert_query			= "INSERT INTO ".$mb_admin_tables["meta"]." (`".$fields["fn_meta_table"]."`,`".$fields["fn_meta_pid"]."`,`".$fields["fn_meta_key"]."`,`".$fields["fn_meta_value"]."`) VALUES ";
					$insert_value			= array();
					foreach($options_name as $key=>$value){
						$insert_value[]		= $mdb->prepare("('commerce_product_op02_name',%d,%s,%s)",$board_pid,$key,$value);					
					}
					foreach($options_count as $key=>$value){
						$insert_value[]		= $mdb->prepare("('commerce_product_op02_count',%d,%s,%s)",$board_pid,$key,$value);					
					}
					$insert_query			.= implode(",",$insert_value).";";
					$mdb->query($insert_query);
				}
			}
		}
	}
}
add_action('mbw_board_api_footer', 'mbw_board_product_api_footer',5); 

if(!function_exists('mbw_board_product_api_init')){
	function mbw_board_product_api_init(){
		if((mbw_get_param("board_name")=="commerce_product" || mbw_get_param("board_name")=="commerce_lecture") && mbw_get_param("mode")=="write"){
			add_filter( 'mf_board_send_data', 'mbw_commerce_product_option_filter', 22, 1);
		}
		if(mbw_get_param("board_action")=="board_hit"){
			$cookie_value		= "";
			$cookie_name		= "mb_product_hit";
			if(mbw_get_cookie($cookie_name)!=""){
				$cookie_value	= ",".mbw_get_cookie($cookie_name).",";
				$check_value		= ",".mbw_get_param("board_pid").",";
				if(strpos($cookie_value,$check_value)!==false){
					$cookie_value		= str_replace($check_value, ",", $cookie_value);
				}else{
					$cookie_value		= rtrim($cookie_value,",");
					$cookie_array		= explode(',',$cookie_value);
					if(count($cookie_array)>10){
						array_pop($cookie_array);
						$cookie_value		= implode(',',$cookie_array);
					}
				}
				$cookie_value		= mbw_get_param("board_pid").$cookie_value;
				$cookie_value		= rtrim($cookie_value,",");
			}else{
				$cookie_value	= mbw_get_param("board_pid");
			}
			mbw_set_cookie($cookie_name, $cookie_value, (mbw_get_timestamp()+2592000));
		}
	}
}
add_action('mbw_board_api_init', 'mbw_board_product_api_init',5);

//상품 옵션 가격 위변조 체크
if(!function_exists('mbw_commerce_product_option_validate')){
	function mbw_commerce_product_option_validate($type,$pid,$name="",$price=0){
		global $mdb,$mb_commerce_tables,$mb_fields;
		$option_price				= floatval($price);
		$option_name				= $name;
		$result_type					= 0;
		$price_state					= false;		
		$fields							= $mb_fields["commerce_product"];
		$product_pid					= mbw_get_param("board_pid");
		$product_item				= mbw_get_vars("product_item_".$product_pid);
		if(empty($product_item)){
			$select_query				= $mdb->prepare("select * from `".$mb_commerce_tables["commerce_product"]."` where `".$fields["fn_pid"]."`=%s", $pid);
			$product_item				= $mdb->get_row($select_query,ARRAY_A);
			mbw_set_vars("product_item_".$product_pid,$product_item);
		}
		if(!empty($product_item)){
			$product_options			= $product_item[$fields["fn_product_options"]];
			$product_options_type		= $product_item[$fields["fn_product_options_type"]];
			if(!empty($product_options)){

				$product_options					= maybe_unserialize($product_options);
				if(!empty($product_options)){
					$option_data			= array();
					if($product_options_type=="mc-op02"){
						$t_name	= $type."_options2";
					}else{
						$t_name	= $type."_options";
					}
					if(!empty($product_options[$t_name])){
						$option_data		= $product_options[$t_name];
						$check_value		= "";
						$check_price		= 0;						

						if($product_options_type=="mc-op01" || ($product_options_type=="mc-op02" && $type=="add")){
							if(!empty($option_data["value"])){
								$t_value				= "";
								$t_price				= "";
								$check_index			= -1;
								$count1				= count($option_data["value"]);
								$i						= 0;
								for($i=0;$i<$count1;$i++){
									if(isset($option_data["value"][$i]) && isset($option_data["price"][$i])){
										$t_value	= mbw_htmlspecialchars_decode($option_data["value"][$i]);
										$t_price	= mbw_htmlspecialchars_decode($option_data["price"][$i]);

										if($check_index!=-1){
											$t_value			= explode("||",$t_value);
											if(isset($t_value[$check_index])){
												$t_value			= $t_value[$check_index];
											}
											$t_price			= explode("||",$t_price);
											if(isset($t_price[$check_index])){
												$t_price			= $t_price[$check_index];
											}
										}
										$option_value_array	= explode(",",$t_value);
										//$option_price_array	= explode(",",str_replace("-","",$t_price));
										$option_price_array	= explode(",",$t_price);
										$count2				= count($option_value_array);
										for($j=0;$j<$count2;$j++){
											if($option_name==$check_value.$option_value_array[$j]){
												$check_value		.= $option_value_array[$j];
												$check_price		+= floatval($option_price_array[$j]);
												$price_state		= true;
												break;
											}else if(strpos($option_name,$check_value.$option_value_array[$j].' / ')===0){
												$check_value		.= $option_value_array[$j].' / ';
												$check_price		+= floatval($option_price_array[$j]);
												$check_index		= $j;
											}
										}
										if($price_state) break;
									}
								}
							}
						}else if($product_options_type=="mc-op02"){
							$option_data						= json_decode($option_data,true);
							if(!empty($option_data)){
								foreach($option_data as $item1){
									if($option_name==$check_value.$item1['option_name']){
										$check_value		.= $item1['option_name'];
										$check_price		+= floatval($item1['option_add_price']);
										$price_state		= true;
										break;
									}else if(strpos($option_name,$check_value.$item1['option_name'].' / ')===0){
										$check_value		.= $item1['option_name'].' / ';
										$check_price		+= floatval($item1['option_add_price']);

										if(!empty($item1['children'])){
											foreach($item1['children'] as $item2){
												if($option_name==$check_value.$item2['option_name']){
													$check_value		.= $item2['option_name'];
													$check_price		+= floatval($item2['option_add_price']);
													$price_state		= true;
													break;
												}else if(strpos($option_name,$check_value.$item2['option_name'].' / ')===0){
													$check_value		.= $item2['option_name'].' / ';
													$check_price		+= floatval($item2['option_add_price']);
													if(!empty($item2['children'])){
														foreach($item2['children'] as $item3){
															if($option_name==$check_value.$item3['option_name']){
																$check_value		.= $item3['option_name'];
																$check_price		+= floatval($item3['option_add_price']);
																$price_state		= true;
																break;
															}
														}
													}
												}
											}
										}
									}
									if($price_state) break;
								}
							}
						}	//mc-op02
						
						if($price_state && $option_price!=$check_price){
							log_trace("** 상품 옵션 가격 위변조 체크기능 동작 **");
							log_trace("상품 PID: ".$pid.", 회원 PID: ".mbw_get_user("fn_pid"));
							log_trace("신청옵션: ".$option_name." (".$option_price."원)");
							log_trace("정상옵션: ".$check_value." (".$check_price."원)");

							if($option_price<$check_price){
								$option_price		= $check_price;
								$result_type			= 1;
								log_trace("처리결과: 정상옵션 가격으로 변경해서 적용");
							}
						}

					}
				}
			}
		}
		//일치하는 옵션명을 찾지 못했을 경우에는 마이너스 옵션가격 허용 안함
		if(!$price_state){
			$result_type		= 2;
			if($option_price<0){		
				$option_price		= abs($option_price);
			}
		}
		return array("price"=>$option_price,"type"=>$result_type);
	}
}
if(!function_exists('mbw_commerce_product_api_init')){
	function mbw_commerce_product_api_init(){
		$option_html			= "";
		$option_price		= 0;
		$order_count		= 0;

		if(mbw_get_param("product_required_options")!="" || mbw_get_param("product_required_options2")!=""){
			if(mbw_get_param("product_required_options")!=""){
				$product_required_options					= mbw_get_param("product_required_options");		
				$product_required_options_count		= mbw_get_param("product_required_options_count");
			}else if(mbw_get_param("product_required_options2")!=""){
				$product_required_options					= mbw_get_param("product_required_options2");		
				$product_required_options_count		= mbw_get_param("product_required_options_count2");
			}
			$sale_price		= floatval(mbw_get_param("sale_price"));
			$index				= 0;
			$option_html		.= '<div class="mc-order-required-options">';			

			foreach($product_required_options as $value){
				$option_data		= explode("||",strip_tags($value));
				$count				= abs(intval($product_required_options_count[$index]));
				$order_count		= $order_count+$count;
				if(empty($option_data[1])){
					$option_data[1]	= 0;
					$option_html		.= '<div><span>'.$option_data[0].' </span>/<span> '.$count.'개  </span></div>';					
				}else{
					$option_data[1]		= floatval($option_data[1]);
					$result_data			= mbw_commerce_product_option_validate("required",mbw_get_param("board_pid"),$option_data[0],$option_data[1]);
					$add_class			= "";
					if(!empty($result_data["type"])){
						$option_data[1]	= $result_data["price"];
						$add_class		= ' class="mc-option-style'.$result_data["type"].'"';
					}

					$option_html		.= '<div><span'.$add_class.'>';
						$option_html		.= '<span>'.$option_data[0].' </span>/<span> '.$count.'개 </span>/';
						if($option_data[1]>=0){
							$option_html		.= '<span> +'.mbw_set_format(($option_data[1])*($count)).'</span>';
						}else{
							$option_html		.= '<span> '.mbw_set_format(($option_data[1])*($count)).'</span>';
						}
					$option_html		.= '</span></div>';
				}
				if(!empty($option_data[2])){
					$option_html		.= '<input type="hidden" name="check_product_options[]" value="op02___'.$option_data[0].'___'.mbw_get_param("board_pid").'___'.$option_data[2].'___'.$count.'" />';
				}
				$option_price		= $option_price+($option_data[1]*$count);
				$index++;
			}
			$option_html		.= '</div>';
		}
		if(mbw_get_param("product_add_options")!="" || mbw_get_param("product_add_options2")!=""){
			if(mbw_get_param("product_add_options")!=""){
				$product_add_options						= mbw_get_param("product_add_options");
				$product_add_options_count				= mbw_get_param("product_add_options_count");
			}else if(mbw_get_param("product_add_options2")!=""){
				$product_add_options						= mbw_get_param("product_add_options2");		
				$product_add_options_count				= mbw_get_param("product_add_options_count2");
			}
			$index				= 0;
			$option_html		.= '<div class="mc-order-add-options">';		
			foreach($product_add_options as $value){			
				$option_data		= explode("||",strip_tags($value));
				$count			= abs(intval($product_add_options_count[$index]));
				if(empty($option_data[1])){
					$option_data[1]	= 0;
					$option_html		.= '<div><span>'.$option_data[0].' </span>/<span> '.$count.'개  </span></div>';					
				}else{
					$option_data[1]		= floatval($option_data[1]);
					$result_data			= mbw_commerce_product_option_validate("add",mbw_get_param("board_pid"),$option_data[0],$option_data[1]);
					$add_class			= "";
					if(!empty($result_data["type"])){
						$option_data[1]	= $result_data["price"];
						$add_class		= ' class="mc-option-style'.$result_data["type"].'"';
					}

					$option_html		.= '<div><span'.$add_class.'>';
						$option_html		.= '<span>'.$option_data[0].' </span>/<span> '.$count.'개 </span>/';
						if($option_data[1]>=0){
							$option_html		.= '<span> +'.mbw_set_format(($option_data[1])*($count)).'</span>';
						}else{
							$option_html		.= '<span> '.mbw_set_format(($option_data[1])*($count)).'</span>';
						}
					$option_html		.= '</span></div>';
				}
				$option_price		= $option_price+($option_data[1]*$count);
				$index++;
			}
			$option_html		.= '</div>';
			if($order_count==0) $order_count=1;
		}	
		if(!empty($option_html)) mbw_set_param("order_options",$option_html);
		if(!empty($option_price)) mbw_set_param("order_options_price",$option_price);
		if(!empty($order_count)) mbw_set_param("order_count",$order_count);
	}
}
add_action('mbw_commerce_api_init', 'mbw_commerce_product_api_init',5);


if(!function_exists('mbw_filter_board_skin_path')){			
	function mbw_filter_board_skin_path($path){
		$file_path		= $path;
		if(mbw_get_param("mode")=="view"){
			$file_path["base"]			= MBW_PLUGIN_PATH."plugins/commerce/";
			$file_path["prefix"]		= "commerce-";
			$file_path["mode"]		= "product-view";
		}
		return $file_path;
	}
}
add_filter('mf_board_skin_path', 'mbw_filter_board_skin_path',5,1); 


if(!function_exists('mbw_get_sale_status_search_template')){
	function mbw_get_sale_status_search_template( $post_ID=0 ){
		global $mb_commerce_lecture_status;
		echo '<div class="border-bottom-ccc-1" style="margin-bottom:10px !important;padding:10px 0 !important;text-align:right;">';
			echo '<p>';	
			$search_field		= 	"fn_sale_status";
			$input_values		= __MW("W_ALL").",".implode(",",$mb_commerce_lecture_status);
			$input_keys			= ",".implode(",",array_keys($mb_commerce_lecture_status));
			if(mbw_get_vars("device_type")=="mobile"){
				$input_type			= "select";
				$input_width			= "100%";
			}else{
				$input_type			= "radio";
				$input_width			= "100px";
			}
			echo '<input type="hidden" name="search_add_field1" value="'.$search_field.'" />';
			echo mbw_get_item_template("search",array("item_name"=>"search_add_text1","type"=>$input_type,"width"=>$input_width,"data"=>$input_keys,"label"=>$input_values,"value"=>mbw_get_param("search_add_text1")));
			echo '</p>';
		echo '</div>';
	}
}


$mb_words["Write"]												= "W_LECTURE_WRITE";
$mb_languages["MSG_LIST_ITEM_EMPTY"]				= $mb_languages["MSG_LIST_LECTURE_ITEM_EMPTY"];

mbw_set_messages($mb_languages);
mbw_set_board_where(array("field"=>"fn_product_type", "value"=>"lecture"));

if(mbw_is_admin_page()){		//어드민 페이지에서만 실행
	add_action('mbw_board_skin_search', 'mbw_get_sale_status_search_template');
}else {
	if(mbw_get_param("mode")=="view"){
		mbw_set_board_option("fn_list_level",99);
		mbw_set_board_option("fn_write_level",99);
	}else{
		$site_url			= mbw_check_url(MBW_HOME_URL);
		$product_url		= mbw_check_permalink(mbw_get_option("post_product"));
		$lecture_url		= mbw_check_permalink(mbw_get_option("post_lecture"));
		if(($product_url!=$site_url && strpos(mbw_get_current_url(),$product_url)===0) || ($lecture_url!=$site_url && strpos(mbw_get_current_url(),$lecture_url)===0)){
			if(mbw_get_param("mode")=="write" && mbw_get_param("board_action")=="modify"){
				if(mbw_is_user_pid() || intval(mbw_get_board_option("fn_modify_level")) <= intval(mbw_get_user("fn_user_level"))){
					//본인 글이거나 수정권한이 있을 경우
				}else{
					mbw_set_board_where(array("field"=>"fn_user_pid", "value"=>mbw_get_user("fn_pid")));
				}
			}else{
				mbw_set_board_where(array("field"=>"fn_user_pid", "value"=>mbw_get_user("fn_pid")));
			}
			if(mbw_get_request_mode()=="Frontend"){
				add_action('mbw_board_skin_search', 'mbw_get_sale_status_search_template');

				if(!mbw_is_admin() && !mbw_is_commerce_group()){
					mbw_set_board_option("fn_list_level",mbw_get_option("manager_level"));
					mbw_set_board_option("fn_write_level",mbw_get_option("manager_level"));
					mbw_set_board_where(array("field"=>"fn_is_show", "value"=>"1", "sign"=>"="));
					$user_level				= mbw_get_user("fn_user_level");
					if(mbw_is_login() && intval(mbw_get_option("manager_level")) > intval($user_level)){
						global $mb_error_message;
						$error_message				= "상품판매 그룹에 등록된 회원이 아닙니다";
						$mb_error_message[]		= $error_message;
						mbw_set_result_data(array("message"=>$error_message));
					}
				}
			}
		}else{
			mbw_set_board_where(array("field"=>"fn_is_show", "value"=>"1", "sign"=>"="));
			if(!mbw_is_commerce_group()){
				mbw_set_board_option("fn_write_level",mbw_get_option("manager_level"));				
			}
		}
	}
	mbw_is_permission_level();	

	//상품 템플릿 모드
	if(mbw_get_vars("shortcode")=="commerce"){

		//사용자 페이지에서는 랭킹순 정렬을 기본으로 설정
		if(mbw_get_param("order_by")=="" || mbw_get_param("order_by")=="fn_pid"){
			mbw_set_param("order_by","fn_product_rank1");
		}
		if(mbw_get_param("order_type")=="") mbw_set_param("order_type","desc");	
	}

	if(mbw_get_param("start_price")!=""){
		$start_price		= floatval(str_replace(",","", mbw_get_param("start_price")));
		mbw_set_board_where(array("field"=>$mb_fields["commerce_product"]["fn_sale_price"], "value"=>$start_price, "sign"=>">="));
		if(mbw_get_param("end_price")!=""){
			$end_price		= floatval(str_replace(",","", mbw_get_param("end_price")));
			mbw_set_board_where(array("field"=>$mb_fields["commerce_product"]["fn_sale_price"], "value"=>$end_price, "sign"=>"<="));
		}
	}
}
?>