<?php
$desktop_model					= array();
$tablet_model					= array();
$mobile_model				= array();
$desktop_model['version']		= "1.0.0";


$desktop_model['list']		= '
{"field":"fn_reg_date","name":"주문일자","width":"136px","type":"commerce_order_date","class":"","search":"false","responsive":"mb-hide-mobile"},
{"field":"fn_order_products","name":"주문 상품 정보","width":"","mobile_width":"210px","type":"commerce_order_products_btn","class":"","td_style":"text-align:left","responsive":""},
{"field":"fn_regular_price","name":"결제금액","type":"commerce_sales_table_price","width":"120px","order":"false","responsive":"mb-hide-mobile mb-hide-tablet","search":"false"},
{"name":"주문상태","width":"90px","mobile_width":"74px","type":"commerce_btn_list_order","class":"commerce_btn_list_order","search":"false"},
';

//주문내역, 주문목록 글보기 모델 수정
$desktop_model['view']		= '
{"tpl":"tag","tag_name":"table","type":"start","name":"글보기","width":"17%,*","mobile_width":"90px,*","class":"table table-order"},
{"field":"fn_billing_id","name":"주문번호","width":"300px","type":"commerce_billing_id_receipt"},
{"field":"fn_reg_date","name":"주문일자","width":"300px"},
{"field":"fn_pay_method","name":"주문상태","width":"300px","type":"commerce_btn_view_order"},
{"field":"fn_user_email","name":"이메일","width":"300px","display_check":"empty:none"},
{"field":"fn_user_phone","name":"연락처","width":"300px","display_check":"empty:none"},
{"field":"fn_order_price","name":"결제금액","width":"300px","format":"currency","type":"commerce_order_price_shipping"},
{"field":"fn_order_count","name":"주문수량","width":"70px","format":"개","type":"commerce_order_count_text"},
{"field":"fn_pay_bank_account","name":"입금계좌","width":"300px","display_check":"empty:none"},
{"field":"fn_order_products","name":"주문 상품 정보","width":"","type":"commerce_order_products_complete","class":"","colspan":"2"},
{"field":"fn_shipping_address1","name":"배송지 정보","width":"","type":"commerce_address_view_shipping","class":""},
{"field":"fn_order_memo","name":"배송 요구사항","width":"","display_check":"empty:none"},
{"field":"fn_shipping_info","name":"배송 정보","width":"","type":"commerce_shipping_info","class":""},
{"tpl":"tag","tag_name":"table","type":"end"}
';

$tablet_model									= $desktop_model;
$mobile_model								= $desktop_model;
mbw_set_fields("select_board",$mb_fields["commerce_order"]);

$mb_languages["MSG_LIST_ITEM_EMPTY"]						= "등록된 주문이 없습니다";
mbw_set_messages($mb_languages);

function mbw_filter_board_skin_path($path){
	$file_path		= $path;
	if(mbw_get_param("mode")=="list"){
		$file_path["base"]			= MBW_PLUGIN_PATH."plugins/commerce/";
		$file_path["prefix"]		= "commerce-";
		$file_path["mode"]		= "order-".mbw_get_param("mode");
	}
	return $file_path;
}
add_filter('mf_board_skin_path', 'mbw_filter_board_skin_path',5,1); 

mbw_set_option("use_list_button",0);
mbw_set_option("use_view_button",0);
mbw_set_option("use_view_comment",0);
mbw_set_option("use_view_prev_next",0);


if(!function_exists('mbw_order_header_title')){
	function mbw_order_header_title($w_title){
		if(is_array($w_title)){
			if(isset($w_title["title"])) $w_title["title"]		= "주문 상세보기";
		}else{
			$w_title		= "주문 상세보기";
		}
		return $w_title;
	}
}
if(!function_exists('mbw_board_skin_footer_my_order')){	
	function mbw_board_skin_footer_my_order(){
		if(mbw_get_param('mode')=='view' && mbw_get_param('board_pid')!='' && mbw_get_option("commerce_pay_pg")=='inicis' && mbw_get_option("commerce_pg_inicis_mid")!='' && mbw_get_option("commerce_pg_inicis_key")!=''){
			echo '<div class="btn-box-left" style="">';
				if(mbw_get_board_item("fn_pay_state")=="complete" && mbw_get_option("use_bank_cash_receipt")){
					$order_price		= intval(mbw_get_board_item('fn_order_price'));
					if(mbw_get_board_item('fn_pay_method')=='bank' && $order_price>0){
						if(mbw_get_board_item('fn_pay_tid')==''){
							$allow_date			= date("Y-m-d H:i:s", (mbw_get_timestamp()-(60*60*24*30)));
							if(mbw_get_board_item('fn_pay_date')>$allow_date){
								echo '<a href="'.MBW_HOME_URL.'/?mb_commerce=cash_receipt&board_name=commerce_my_order&vid='.mbw_get_param('board_pid').'&billing_id='.mbw_get_board_item('fn_billing_id').'" target="_blank" class="btn btn-default" title="현금영수증 신청" type="button"><span>현금영수증 신청</span></a>';
							}							
						}else if(strpos(mbw_get_board_item('fn_pay_tid'),'INIphpRECP')===0){
							echo '<a href="https://iniweb.inicis.com/DefaultWebApp/mall/cr/cm/Cash_mCmReceipt.jsp?noTid='.mbw_get_board_item('fn_pay_tid').'" + "&clpaymethod=22" target="_blank" class="btn btn-default" title="현금영수증 확인" type="button"><span>현금영수증 확인</span></a>';
						}
					}
				}
			echo '</div>';
		}
	}
}
add_action('mbw_board_skin_footer', 'mbw_board_skin_footer_my_order',5);

if(mbw_is_login()){
	//관리자 모드가 아니면 본인글만 보이도록 설정
	if(!mbw_is_admin_page()){
		if(mbw_is_admin() && mbw_get_param('mode')=='view'){
			//mbw_set_board_where(array("field"=>"fn_user_pid", "value"=>mbw_get_user("fn_pid")));
		}else{
			mbw_set_board_where(array("field"=>"fn_user_pid", "value"=>mbw_get_user("fn_pid")));
		}

		//주문 상세보기 페이지 페이지 타이틀 수정
		if(mbw_get_param('mode')=='view'){
			//본인의 주문인지 체크
			if(!mbw_is_user_pid("permission") && !mbw_is_admin()){
				mbw_set_result_data(array("state"=>"error","script"=>mbw_get_move_script("permission_login")));
				if(mbw_get_request_mode()=="Frontend"){
					mbw_error_message(array("MSG_PERMISSION_ERROR"), __MW("W_ACCESS"),"1102");
				}
			}
			if(current_theme_supports('title-tag')){
				add_filter('document_title_parts','mbw_order_header_title',26,1);
			}else{
				add_filter('wp_title','mbw_order_header_title',26,1);
			}
		}
	}
}else {
	mbw_set_board_where(array("field"=>"fn_user_pid", "value"=>0));
	if(mbw_get_request_mode()=="Frontend"){
		mbw_set_result_data(array("state"=>"error","script"=>mbw_get_move_script("login")));
	}else exit;
}
?>