<?php
if(!defined('_MB_')) exit();
//사용 주소
//https://www.mangboard.com/?mb_commerce=ep_naver&type=new&mode=summary
//https://www.mangboard.com/?mb_commerce=ep_daum

$board_items		= array();
$size					= 1000;
$type					= "all";
$mode				= "list";
$ep					= "ep_naver";

if(!empty($_GET["mb_commerce"])) $ep		= $_GET["mb_commerce"];
if(!empty($_GET["size"])) $size		= intval($_GET["size"]);

if(!empty($_GET["type"])) $type		= ($_GET["type"]);
if(!empty($_GET["mode"])) $mode	= ($_GET["mode"]);

global $mb_fields,$mb_commerce_tables;

$order_data					= array();
$order_data["pid"]		= "DESC";
$where_data				= array();
$where_data[]				= array("field"=>"sale_status","value"=>1);
if($mode=="summary"){
	$yesterday			= date(mbw_get_option("date_format")." ".mbw_get_option("time_format"), mbw_get_timestamp()-86400);
	$where_data[]		= array("field"=>"modify_date","value"=>$yesterday,"sign"=>">");		
}

$column		= "*";
$select_query		= mbw_get_add_query(array("column"=>$column,"join"=>"none","table"=>$mb_commerce_tables["commerce_product"]), $where_data,$order_data)." limit 0,".$size;
//echo $select_query;
$board_items		= mbw_get_board_items_query($select_query);

$tag_start			= "<<<";
$tag_end			= ">>>";
$line_end			= "\n";
$tab					= "\t";

$template_start	= "";
$template_end		= "";

if($ep=="ep_naver"){
	if($mode!="summary"){
		$template_start	= "id".$tab."title".$tab."price_pc".$tab."normal_price".$tab."link".$tab."image_link".$tab."category_name1".$tab."category_name2".$tab."category_name3".$tab."model_number".$tab."brand".$tab."origin".$tab."point".$tab."shipping";

		foreach($board_items as $item){

			$template_start	.= $line_end.trim($item["pid"]).$tab;
			$template_start	.= trim(mbw_htmlspecialchars_decode($item["title"])).$tab;
			$template_start	.= trim($item["sale_price"]).$tab;
			$template_start	.= trim($item["regular_price"]).$tab;
			$template_start	.= trim(mbw_get_url(array('vid'=>$item["pid"]),mbw_get_product_view_url(),"")).$tab;
			$template_start	.= trim(mbw_get_image_url("url",$item["image_path"])).$tab;	
			$template_start	.= trim(mbw_htmlspecialchars_decode($item["category1"])).$tab;
			$template_start	.= trim(mbw_htmlspecialchars_decode($item["category2"])).$tab;
			$template_start	.= trim(mbw_htmlspecialchars_decode($item["category3"])).$tab;
			$template_start	.= trim($item["product_model"]).$tab;
			$template_start	.= trim($item["product_brand"]).$tab;
			$template_start	.= trim($item["product_origin"]).$tab;
			$template_start	.= trim($item["product_point"]).$tab;
			$template_start	.= trim($item["shipping_cost"]);
		}
	}else{

		$template_start	= "id".$tab."title".$tab."price_pc".$tab."normal_price".$tab."link".$tab."image_link".$tab."category_name1".$tab."category_name2".$tab."category_name3".$tab."model_number".$tab."brand".$tab."origin".$tab."point".$tab."shipping".$tab."class".$tab."update_time";

		foreach($board_items as $item){

			$template_start	.= $line_end.trim($item["pid"]).$tab;
			$template_start	.= trim(mbw_htmlspecialchars_decode($item["title"])).$tab;
			$template_start	.= trim($item["sale_price"]).$tab;
			$template_start	.= trim($item["regular_price"]).$tab;
			$template_start	.= trim(mbw_get_url(array('vid'=>$item["pid"]),mbw_get_product_view_url(),"")).$tab;
			$template_start	.= trim(mbw_get_image_url("url",$item["image_path"])).$tab;	
			$template_start	.= trim(mbw_htmlspecialchars_decode($item["category1"])).$tab;
			$template_start	.= trim(mbw_htmlspecialchars_decode($item["category2"])).$tab;
			$template_start	.= trim(mbw_htmlspecialchars_decode($item["category3"])).$tab;
			$template_start	.= trim($item["product_model"]).$tab;
			$template_start	.= trim($item["product_brand"]).$tab;
			$template_start	.= trim($item["product_origin"]).$tab;
			$template_start	.= trim($item["product_point"]).$tab;
			$template_start	.= trim($item["shipping_cost"]).$tab;
			
			if($item["product_type"]=="lecture"){
				$stock				= intval($item["stock"])-intval($item["sale_count"]);
			}else{
				$stock				= intval($item["stock"]);
			}		
			if($stock<=0){
				$template_start	.= 'D'.$tab;
			}else{
				if($item["reg_date"]==$item["modify_date"]){
					$template_start	.= 'I'.$tab;
				}else{
					$template_start	.= 'U'.$tab;
				}				
			}		
			$template_start	.= trim($item["modify_date"]);		
		}
	}
}else if($ep=="ep_daum"){

	if($mode!="summary"){

		$template_start	.= $tag_start."tocnt".$tag_end.count($board_items).$line_end;

		foreach($board_items as $item){
			$template_start	.= $tag_start."begin".$tag_end.$line_end;
			$template_start	.= $tag_start."mapid".$tag_end.$item["pid"].$line_end;
			$template_start	.= $tag_start."lprice".$tag_end.$item["regular_price"].$line_end;
			$template_start	.= $tag_start."price".$tag_end.$item["sale_price"].$line_end;
			$template_start	.= $tag_start."pname".$tag_end.mbw_htmlspecialchars_decode($item["title"]).$line_end;		
			$template_start	.= $tag_start."pgurl".$tag_end.mbw_get_url(array('vid'=>$item["pid"]),mbw_get_product_view_url(),"").$line_end;
			$template_start	.= $tag_start."igurl".$tag_end.mbw_get_image_url("url",$item["image_path"]).$line_end;	
			$template_start	.= $tag_start."cate1".$tag_end.mbw_htmlspecialchars_decode($item["category1"]).$line_end;
			$template_start	.= $tag_start."caid1".$tag_end.mbw_htmlspecialchars_decode($item["category1"]).$line_end;
			$template_start	.= $tag_start."cate2".$tag_end.mbw_htmlspecialchars_decode($item["category2"]).$line_end;
			$template_start	.= $tag_start."caid2".$tag_end.mbw_htmlspecialchars_decode($item["category2"]).$line_end;		
			$template_start	.= $tag_start."cate3".$tag_end.mbw_htmlspecialchars_decode($item["category3"]).$line_end;
			$template_start	.= $tag_start."caid3".$tag_end.mbw_htmlspecialchars_decode($item["category3"]).$line_end;		
			$template_start	.= $tag_start."cate4".$tag_end.$line_end;

			$template_start	.= $tag_start."model".$tag_end.str_replace(array("  ","   ","    "), "", $item["product_model"]).$line_end;
			$template_start	.= $tag_start."brand".$tag_end.str_replace(array("  ","   ","    "), "", $item["product_brand"]).$line_end;
			$template_start	.= $tag_start."maker".$tag_end.$line_end;

			$pdate				= str_replace("-","",substr($item["reg_date"],0,10));
			$template_start	.= $tag_start."pubdate".$tag_end.$pdate.$line_end;
			$template_start	.= $tag_start."sales".$tag_end.$item["sale_count"].$line_end;
			$template_start	.= $tag_start."pcard".$tag_end.$line_end;

			$template_start	.= $tag_start."point".$tag_end.$item["product_point"].$line_end;
			
			$template_start	.= $tag_start."deliv".$tag_end.$item["shipping_cost"].$line_end;

			$template_start	.= $tag_start."revct".$tag_end.$item["review_count"].$line_end;

			$template_start	.= $tag_start."selid".$tag_end.$item["user_name"].$line_end;
			$template_start	.= $tag_start."ftend".$tag_end.$line_end;
		}

	}else{

		foreach($board_items as $item){
			$template_start	.= $tag_start."begin".$tag_end.$line_end;
			$template_start	.= $tag_start."mapid".$tag_end.$item["pid"].$line_end;
			$template_start	.= $tag_start."lprice".$tag_end.$item["regular_price"].$line_end;
			$template_start	.= $tag_start."price".$tag_end.$item["sale_price"].$line_end;
			$template_start	.= $tag_start."pname".$tag_end.mbw_htmlspecialchars_decode($item["title"]).$line_end;		
			$template_start	.= $tag_start."pgurl".$tag_end.mbw_get_url(array('vid'=>$item["pid"]),mbw_get_product_view_url(),"").$line_end;
			$template_start	.= $tag_start."igurl".$tag_end.mbw_get_image_url("url",$item["image_path"]).$line_end;	


			if(!empty($item["category1"])){
				$template_start	.= $tag_start."cate1".$tag_end.mbw_htmlspecialchars_decode($item["category1"]).$line_end;
				$template_start	.= $tag_start."caid1".$tag_end.substr(str_replace("%","",rawurlencode(mbw_htmlspecialchars_decode($item["category1"]))),-20).$line_end;
			}else{
				$template_start	.= $tag_start."cate1".$tag_end.$line_end;
				$template_start	.= $tag_start."caid1".$tag_end.$line_end;
			}
			if(!empty($item["category2"])){
				$template_start	.= $tag_start."cate2".$tag_end.mbw_htmlspecialchars_decode($item["category2"]).$line_end;
				$template_start	.= $tag_start."caid1".$tag_end.substr(str_replace("%","",rawurlencode(mbw_htmlspecialchars_decode($item["category2"]))),-20).$line_end;
			}
			if(!empty($item["category3"])){
				$template_start	.= $tag_start."cate3".$tag_end.mbw_htmlspecialchars_decode($item["category3"]).$line_end;
				$template_start	.= $tag_start."caid1".$tag_end.substr(str_replace("%","",rawurlencode(mbw_htmlspecialchars_decode($item["category3"]))),-20).$line_end;
			}

			$template_start	.= $tag_start."model".$tag_end.str_replace(array("  ","   ","    "), "", $item["product_model"]).$line_end;
			$template_start	.= $tag_start."brand".$tag_end.str_replace(array("  ","   ","    "), "", $item["product_brand"]).$line_end;
			$template_start	.= $tag_start."maker".$tag_end.$line_end;

			$pdate				= str_replace("-","",substr($item["reg_date"],0,10));
			$template_start	.= $tag_start."pubdate".$tag_end.$pdate.$line_end;
			$template_start	.= $tag_start."sales".$tag_end.$item["sale_count"].$line_end;
			$template_start	.= $tag_start."pcard".$tag_end.$line_end;

			$template_start	.= $tag_start."point".$tag_end.$item["product_point"].$line_end;
			
			$template_start	.= $tag_start."deliv".$tag_end.$item["shipping_cost"].$line_end;

			$template_start	.= $tag_start."revct".$tag_end.$item["review_count"].$line_end;

			$template_start	.= $tag_start."selid".$tag_end.$item["user_name"].$line_end;			

			$mdate				= str_replace(array("-"," ",":"),"",$item["modify_date"]);
			$template_start	.= $tag_start."utime".$tag_end.$mdate.$line_end;

			if($item["product_type"]=="lecture"){
				$stock				= intval($item["stock"])-intval($item["sale_count"]);
			}else{
				$stock				= intval($item["stock"]);
			}		
			if($stock<=0){
				$template_start	.= $tag_start."class".$tag_end.'D'.$line_end;
			}else{
				if($item["reg_date"]==$item["modify_date"]){
					$template_start	.= $tag_start."class".$tag_end.'I'.$line_end;
				}else{
					$template_start	.= $tag_start."class".$tag_end.'U'.$line_end;
				}				
			}
			$template_start	.= $tag_start."ftend".$tag_end.$line_end;

		}
	}
}
echo $template_start;
?>