<?php
$desktop_model					= array();
$tablet_model						= array();
$mobile_model					= array();
$desktop_model['version']		= "1.0.0";

// 결제 관련 모델을 템플릿으로 이전

$desktop_model['list']		= '
{"field":"fn_title","name":"상품/옵션정보","width":"","type":"commerce_title","maxlength":"100","maxtext":"..","td_class":"text-left","order":"false"},
{"field":"fn_order_count","name":"수량","width":"50px","order":"false","responsive":"mb-hide-mobile"},
{"field":"fn_regular_price","name":"상품금액","type":"commerce_product_price","width":"120px","order":"false","responsive":"mb-hide-mobile"},
{"field":"fn_shop_name","name":"판매자","width":"115px","class":"commerce_name","type":"commerce_name","responsive":"mb-hide-mobile mb-hide-tablet","order":"false"}
';
$desktop_model['order_info']		= "";




//배송상품 모델
$desktop_model['commerce_order_shipping']		= '

{"tpl":"tag","tag_name":"div","type":"start","name":"","class":"","style":"width:100%;padding:3px 3px 0 !important;"},
{"tpl":"tag","level":{"sign":"=","num":"0"},"tag_name":"h5","text":"주문자 정보 입력","style":"margin-top:20px;"},
{"type":"checkbox","level":"1","name":"주문자 정보 수정","width":"60px","data":"1","label":"주문자 정보 수정","item_name":"show_buyer_address","event":"onclick=\"showBuyerAddress(this)\""},
{"tpl":"tag","tag_name":"div","type":"end"},

{"tpl":"tag","tag_name":"table","type":"start","name":"주문자 정보","width":"20%,*","mobile_width":"80px,*","class":"table table-write hide","tag_id":"buyer_address_info"},
{"field":"fn_user_name","name":"주문자 이름","width":"150px","maxlength":"20","required":"(*)","item_id":"user_name"},
{"field":"fn_user_email","name":"이메일","width":"200px","type":"commerce_user_email","maxlength":"50","pattern":"email","pattern_error":"정상적인 이메일 주소가 아닙니다"},
{"field":"fn_user_phone","name":"연락처","width":"150px","type":"commerce_user_phone","item_id":"user_phone"},
{"type":"commerce_address_write_buyer","name":"주소","width":"100%"},
{"tpl":"tag","tag_name":"table","type":"end"},


{"tpl":"tag","tag_name":"h5","text":"배송지 정보 입력","style":"margin-top:20px;"},
{"tpl":"tag","tag_name":"table","type":"start","name":"받으시는 분 주소","width":"20%,*","mobile_width":"80px,*","class":"table table-write"},
{"type":"checkbox","name":"배송지 선택","width":"60px","data":"1","default":"0","label":"주문자 정보와 동일","item_name":"copy_address","event":"onclick=\"copyBillingAddress(this)\""},

{"field":"fn_shipping_name","name":"받으시는 분","width":"150px","maxlength":"20","required":"(*)","item_id":"shipping_name"},
{"field":"fn_shipping_phone","name":"연락처","width":"150px","required":"(*)","type":"commerce_user_phone","default":"010-","item_id":"shipping_phone"},
{"type":"commerce_address_write_shipping","name":"주소","width":"100%","required":"(*)","required_field":"fn_shipping_address1"},
{"type":"none","field":"fn_shipping_address2","name":"상세주소","width":"100%","required":"(*)"},
{"field":"fn_order_memo","name":"배송요구사항","width":"100%"},
{"tpl":"tag","tag_name":"table","type":"end"}
';

//배송이 없는 상품 모델
$desktop_model['commerce_order_virtual']		= '
{"tpl":"tag","tag_name":"div","type":"start","name":"","class":"","style":"width:100%;padding:3px 3px 0 !important;"},
{"type":"checkbox","name":"정보 수정","width":"60px","data":"1","label":"주문자 정보 수정","item_name":"show_buyer_address","event":"onclick=\"showBuyerAddress(this)\""},
{"tpl":"tag","tag_name":"div","type":"end"},
{"tpl":"tag","tag_name":"table","type":"start","name":"주문자 정보","width":"20%,*","mobile_width":"80px,*","class":"table table-write hide","tag_id":"buyer_address_info"},
{"field":"fn_user_name","name":"주문자 이름","width":"150px","maxlength":"20","required":"(*)","item_id":"user_name"},
{"field":"fn_user_email","name":"이메일","width":"200px","type":"commerce_user_email","maxlength":"50","pattern":"email","pattern_error":"정상적인 이메일 주소가 아닙니다"},
{"field":"fn_user_phone","name":"연락처","width":"150px","type":"commerce_user_phone","item_id":"user_phone"},
{"type":"commerce_address_write_buyer","name":"주소","width":"100%"},
{"tpl":"tag","tag_name":"table","type":"end"},
';

$tablet_model				= $desktop_model;
$mobile_model				= $desktop_model;

mbw_set_fields("select_board",$mb_fields["commerce_order"]);
mbw_set_board_where(array("field"=>"fn_user_pid", "value"=>mbw_get_user("fn_pid")));

if(!function_exists('mbw_billing_header_title')){	
	function mbw_billing_header_title($w_title){
		if(function_exists('get_the_title')) $title	= get_the_title();
		else $title	= '주문/결제';
		if(is_array($w_title)){
			if(isset($w_title["title"])) $w_title["title"]		= $title;
		}else{
			$w_title		= $title;
		}
		return $w_title;
	}
}
if(mbw_get_request_mode()=="Frontend" && mbw_get_param("mode")=="view"){
	if(current_theme_supports('title-tag')){
		add_filter('document_title_parts','mbw_billing_header_title',35,1);
	}else{
		add_filter('wp_title','mbw_billing_header_title',35,1);
	}
}
?>