<?php
$desktop_model					= array();
$tablet_model					= array();
$mobile_model				= array();
$desktop_model['version']		= "1.0.0";

// Board Model
$desktop_model['list']		= '
{"type":"list_check","width":"50px","tablet_width":"20px","mobile_width":"20px","class":"list_check","event":"onclick=\"selectCartProduct()\""},
{"field":"fn_title","name":"상품/옵션정보","width":"","type":"commerce_title_order","maxlength":"100","maxtext":"..","td_class":"text-left","search":"false"},
{"field":"fn_title","name":"상품명","type":"search"},
{"field":"fn_product_description","name":"상품설명","type":"search"},
{"field":"fn_order_count","name":"수량","width":"110px","mobile_width":"50px","responsive":"","type":"commerce_order_count_modify2"},
{"field":"fn_sale_price","name":"상품금액","type":"commerce_product_price","width":"110px","responsive":"mb-hide-mobile"},
{"name":"","width":"60px","mobile_width":"48px","type":"commerce_btn_list_cart","responsive":"","responsive":"mb-hide-mobile"}
';

$desktop_model['list_admin']		= '
{"type":"list_check","width":"50px","tablet_width":"20px","mobile_width":"20px","class":"list_check","event":"onclick=\"selectCartProduct()\"","responsive":"mb-hide-mobile"},
{"field":"fn_pid","name":"번호","width":"50px","class":"num","type":"pid","class":"pid","responsive":"mb-hide-mobile mb-hide-tablet"},
{"field":"fn_title","name":"상품/옵션정보","width":"","type":"commerce_title_order","maxlength":"100","maxtext":"..","td_class":"text-left","search":"false"},
{"field":"fn_title","name":"상품명","type":"search"},
{"field":"fn_product_description","name":"상품설명","type":"search"},
{"field":"fn_order_count","name":"수량","width":"30px","responsive":"mb-hide-mobile"},
{"field":"fn_sale_price","name":"상품금액","type":"commerce_product_price","width":"110px","responsive":"mb-hide-mobile"},
{"field":"fn_user_name","name":"회원/등록일","width":"140px","mobile_width":"80px","type":"admin_user_name_pid_date","search":"false"},
{"field":"fn_ip","name":"IP","width":"120px","type":"admin_ip_agent","level":"10","responsive":"mb-hide-mobile mb-hide-tablet"},
{"field":"fn_user_name","name":"회원이름","type":"search"},
{"field":"fn_user_pid","name":"W_USER_PID","type":"search"},
{"field":"fn_cart_id","name":"상태","width":"100px","type":"commerce_product_cart_status","search":"false","responsive":"mb-hide-mobile"},
{"field":"fn_sale_price","name":"판매가격","width":"64px","type":"text","responsive":"mb-hide-mobile mb-hide-tablet","style":"max-width:94%;","search":"false"},
{"field":"admin_btn","name":"","name_btn":"수정","width":"60px","type":"admin_option_modify","responsive":"mb-hide-mobile mb-hide-tablet"}
';

if(mbw_is_login()){
	if(!mbw_is_admin_page()){		
		mbw_set_board_where(array("field"=>"fn_user_pid", "value"=>mbw_get_user("fn_pid"), "sign"=>"="));			
		mbw_set_board_where(array("field"=>"fn_cart_id", "value"=>"", "sign"=>"!="));		
	}else{
		mbw_set_board_option("fn_modify_level",10);
	}
}else{
	$cart_id			= mbw_get_cart_id();
	mbw_set_board_where(array("field"=>"fn_cart_id", "value"=>$cart_id, "sign"=>"="));	
	mbw_set_board_where(array("field"=>"fn_user_pid", "value"=>"0", "sign"=>"="));	
}
mbw_set_board_where(array("field"=>"fn_is_order", "value"=>"0"));

$mb_languages["MSG_LIST_ITEM_EMPTY"]						= $mb_languages["MSG_LIST_PRODUCT_ITEM_EMPTY"];
mbw_set_messages($mb_languages);

$tablet_model								= $desktop_model;
$mobile_model								= $desktop_model;
$mobile_model['list']		= '
{"type":"list_check","width":"50px","tablet_width":"20px","mobile_width":"20px","class":"list_check","event":"onclick=\"selectCartProduct()\""},
{"field":"fn_title","name":"상품/옵션정보","width":"","type":"commerce_title_order_cart","maxlength":"100","maxtext":"..","td_class":"text-left","search":"false"},
{"field":"fn_title","name":"상품명","type":"search"},
{"field":"fn_product_description","name":"상품설명","type":"search"},
{"field":"fn_sale_price","name":"상품금액","type":"commerce_product_price","width":"110px","responsive":"mb-hide-mobile"},
';

$mb_fields["select_board"]					= $mb_fields["commerce_cart"];

if(!function_exists('mbw_cart_header_title')){
	function mbw_cart_header_title($w_title){
		if(function_exists('get_the_title')) $title	= get_the_title();
		else $title	= '장바구니';
		if(is_array($w_title)){
			if(isset($w_title["title"])) $w_title["title"]		= $title;
		}else{
			$w_title		= $title;
		}
		return $w_title;
	}
}
if(mbw_get_request_mode()=="Frontend" && mbw_get_param("mode")=="view"){
	if(current_theme_supports('title-tag')){
		add_filter('document_title_parts','mbw_cart_header_title',35,1);
	}else{
		add_filter('wp_title','mbw_cart_header_title',35,1);
	}
}
?>