<?php
$desktop_model					= array();
$tablet_model					= array();
$mobile_model				= array();
$desktop_model['version']		= "1.0.0";


$desktop_model['list']		= '
{"field":"fn_reg_date","name":"주문일자","width":"136px","type":"commerce_order_date","class":"commerce_order_date","search":"false"},
{"field":"fn_order_products","name":"주문 상품 정보","width":"","type":"commerce_order_products_btn","class":"commerce_order_products_btn","td_class":"text-left"},
{"name":"","width":"90px","type":"commerce_btn_list_order","class":"commerce_btn_list_order"},
';

$desktop_model['list_admin']		= '
{"type":"list_check","width":"50px","level":"10","class":"list_check","event":"onclick=\"selectSalesTableProduct()\"","responsive":"mb-mobile-hide"},
{"field":"fn_billing_id","name":"주문번호","type":"search"},
{"field":"fn_shop_pid","name":"판매자(Pid)","type":"search"},
{"field":"fn_reg_date","name":"주문일자","width":"136px","mobile_width":"100px","type":"commerce_order_date","class":"commerce_order_date","search":"false"},
{"field":"fn_title","name":"주문 상품 정보","width":"","td_class":"text-left","link":"view"},
{"field":"fn_sale_price","name":"상품금액","width":"120px","order":"false","format":"currency","responsive":"mb-mobile-hide"},
{"field":"fn_shipping_cost","name":"배송금액","width":"120px","order":"false","format":"currency","responsive":"mb-mobile-hide"},
{"field":"fn_regular_price","name":"결제금액","type":"commerce_sales_table_price","width":"120px","mobile_width":"85px","order":"false"},
{"field":"fn_shop_name","name":"판매자","width":"115px","class":"user_name","responsive":"mb-mobile-hide"},
{"field":"fn_ip","name":"IP","width":"120px","type":"admin_ip_agent","level":"10","responsive":"mb-hide-mobile mb-hide-tablet"},
{"field":"fn_user_name","name":"주문자","type":"search"},
';

//글보기 스킨 수정
$desktop_model['view']		= '
{"tpl":"tag","tag_name":"table","type":"start","name":"글보기","width":"200px,*","mobile_width":"90px,*","class":"table table-view"},

{"field":"fn_billing_id","name":"주문번호","width":"300px"},
{"field":"fn_order_price","name":"결제금액","width":"300px","format":"currency","type":"commerce_order_price_shipping"},
{"field":"fn_shipping_cost","name":"배송금액","width":"300px","format":"currency"},
{"field":"fn_reg_date","name":"주문일자","width":"300px"},

{"field":"fn_order_products","name":"주문 상품 정보","width":"","type":"commerce_order_products_complete","class":"commerce_order_products","colspan":"2"},
{"field":"fn_buyer_address1","name":"주문자 정보","width":"","type":"commerce_address_view_buyer","class":"commerce_address_view_buyer"},
{"field":"fn_shipping_address1","name":"배송지 정보","width":"","type":"commerce_address_view_shipping","class":"commerce_address_view_shipping"},
{"field":"fn_shipping_info","name":"배송 정보","width":"","type":"commerce_shipping_info","class":"commerce_shipping_info"},

{"tpl":"tag","tag_name":"table","type":"end"}
';

//결제완료 보기 스킨 수정
$desktop_model['view-payment']		= '
{"tpl":"tag","tag_name":"table","type":"start","name":"글보기","width":"200px,*","mobile_width":"90px,*","class":"table table-view"},

{"field":"fn_billing_id","name":"주문번호","width":"300px"},
{"field":"fn_sale_price","name":"주문금액","width":"300px","format":"currency"},
{"field":"fn_shipping_cost","name":"배송금액","width":"300px","format":"currency"},
{"field":"fn_reg_date","name":"주문일자","width":"300px"},

{"field":"fn_order_products","name":"주문 상품 정보","width":"","type":"commerce_order_products_complete","class":"commerce_order_products","colspan":"2"},
{"field":"fn_shipping_address1","name":"배송지 정보","width":"","type":"commerce_address_view_shipping","class":"commerce_address_view_shipping"},

{"tpl":"tag","tag_name":"table","type":"end"}
';

//글작성 스킨 수정
$desktop_model['write']		= '
{"tpl":"tag","tag_name":"table","type":"start","name":"글쓰기","width":"200px,*","mobile_width":"90px,*","class":"table table-write"},
{"field":"fn_billing_id","name":"주문번호","width":"300px","type":"static"},
{"field":"fn_reg_date","name":"주문일자","width":"300px","type":"static"},
{"field":"fn_order_price","name":"결제금액","width":"300px"},
{"field":"fn_order_products","name":"주문 상품 정보","width":"","type":"commerce_order_products_complete","class":"commerce_order_products","colspan":"2"},
{"field":"fn_buyer_address1","name":"주문자 주소","width":"","type":"commerce_address_buyer","class":""},
{"field":"fn_user_phone","name":"주문자 연락처","width":"","class":""},
{"field":"fn_user_email","name":"주문자 이메일","width":"","class":""},
{"field":"fn_shipping_address1","name":"받는분 주소","width":"","type":"commerce_address_shipping","class":""},
{"field":"fn_shipping_phone","name":"받는분 연락처","width":"","class":""},
{"field":"fn_order_memo","name":"배송 요구사항","width":"","display_check":"empty:none"},
{"tpl":"tag","tag_name":"table","type":"end"}
';

$tablet_model									= $desktop_model;
$mobile_model								= $desktop_model;
mbw_set_fields("select_board",$mb_fields["commerce_order"]);



function mbw_filter_board_skin_path($path){
	$file_path		= $path;
	if(mbw_get_param("mode")=="list"){
		$file_path["base"]			= MBW_PLUGIN_PATH."plugins/commerce/";
		$file_path["prefix"]		= "commerce-";
		$file_path["mode"]		= "sales-table";
	}
	return $file_path;
}
add_filter('mf_board_skin_path', 'mbw_filter_board_skin_path',5,1); 



function mbw_get_order_state_search_template( $post_ID=0 ){
	global $mb_commerce_order_state;

	echo '<div class="border-bottom-ccc-1" style="margin-bottom:10px !important;padding:10px 0 !important;text-align:right;">';
		mbw_create_search_template("date_range");
	echo '</div>';
}

if(mbw_is_login()){
	mbw_set_board_where(array("field"=>"fn_pay_state", "value"=>"complete"));
	//관리자 모드가 아니면 본인글만 보이도록 설정
	if(!mbw_is_admin_page()){
		mbw_set_board_where(array("field"=>"fn_user_pid", "value"=>mbw_get_user("fn_pid")));
	}
	if((mbw_is_admin() || mbw_is_commerce_group()) && mbw_get_request_mode()=="Frontend"){		// 게시판 모드일 경우에만
		add_action('mbw_board_skin_search', 'mbw_get_order_state_search_template');		// 기간 설정 템플릿 추가

		$titles	= "주문번호,주문자 이름,주문자 이메일,주문자 연락처,상품정보,상품금액,배송비,결제금액,판매자,받는분 이름,우편번호,주소1,주소2,총주소,전화번호,등록일,배송회사,송장번호";
		$fields	= "fn_billing_id,fn_user_name,fn_user_email,fn_user_phone,fn_order_products,fn_sale_price,fn_shipping_cost,fn_order_price,fn_shop_name,fn_shipping_name,fn_shipping_postcode,fn_shipping_address1,fn_shipping_address2,fn_shipping_address,fn_shipping_phone,fn_reg_date,fn_shipping_company,fn_shipping_code";
		mbw_add_left_button("list",mbw_get_btn_template(array("name"=>"Excel_Save","onclick"=>"sendCommerceExcelData('".$fields."','".$titles."')","class"=>"btn btn-default","title"=>"검색 또는 선택된 주문을 Excel 파일로 저장합니다")));
	}
	if(mbw_get_param("start_date")!='' || mbw_get_param("search_text")!=''){		
		mbw_set_board_option("fn_page_size",500);
	}
}else{
	if(mbw_get_request_mode()=="Frontend"){
		mbw_set_result_data(array("state"=>"error","script"=>mbw_get_move_script("login")));
	}else exit;
}
?>