<?php
//주문 완료시 처리 액션
add_action('mbw_commerce_api_footer', 'mbw_commerce_mail_api_footer',5);
if(!function_exists('mbw_commerce_mail_api_footer')){
	function mbw_commerce_mail_api_footer(){	
		$order_action		= array("order_virtual","order_shipping");
		//주문 결과 메일 보내기 템플릿 불러오기
		if(in_array(mbw_get_param("board_action"), $order_action)!==false && mbw_get_param("billing_id")!=""){
			$template_path				= mbw_get_template_path("commerce/mail/order_result","theme");			
		//배송 안내 메일 보내기 템플릿 불러오기
		}else if(mbw_get_param("board_action")=="send_shipping_mail" && mbw_get_param("board_pid")!=""){
			$template_path				= mbw_get_template_path("commerce/mail/shipping","theme");
			mbw_set_result_data(array("message"=>__MM('MSG_SEND_MAIL_SUCCESS')));			
		}else if(mbw_get_param("board_action")=="modify_order_state" && mbw_get_param("order_state")!=""){
			//주문상태 변경 메일 발송
			$template_path				= mbw_get_template_path("commerce/mail/order_change","theme");
		}else if(mbw_get_param("board_action")=="send_shipping_sms" && mbw_get_param("user_phone")!=""){
			if(function_exists('mbw_send_sms')){
				$user_phone		= mbw_get_param("user_phone");
				$sms_title			= mbw_get_param("sms_title");
				$sms_content		= mbw_get_param("sms_content");
				mbw_send_sms($user_phone,$sms_content,$sms_title);
				mbw_set_result_data(array("message"=>'문자가 전송되었습니다'));
			}
		}
		if(!empty($template_path)) require($template_path);
	}
}
//주문 완료시 회원 정보 기본 배송지 저장 기능
add_action('mbw_commerce_api_footer', 'mbw_update_user_order_address',5);
if(!function_exists('mbw_update_user_order_address')){
	function mbw_update_user_order_address(){
		if(mbw_is_login()){			
			$save_basic_address		= mbw_get_param('save_basic_address');			
			if(!empty($save_basic_address)){
				global $mstore,$mdb,$mb_admin_tables,$mb_fields;
				$field							= $mb_fields["users"];
				$shipping_postcode		= mbw_get_param('shipping_postcode');
				$shipping_address1			= mbw_get_param('shipping_address1');
				$shipping_address2			= mbw_get_param('shipping_address2');
				$order_memo				= mbw_get_param('order_memo');		
				$send_data					= array();
				$where_data					= array();
				$send_data[$field["fn_home_postcode"]]		= $shipping_postcode;
				$send_data[$field["fn_home_address1"]]		= $shipping_address1;
				$send_data[$field["fn_home_address2"]]		= $shipping_address2;
				$send_data[$field["fn_user_memo"]]			= $order_memo;
				$where_data[$field["fn_pid"]]					= mbw_get_user('fn_pid');
				$mdb->db_query("UPDATE",$mb_admin_tables["users"], $send_data, $where_data);
			}
		}		
	}
}

//주문 완료시 처리 액션
add_action('mbw_commerce_api_order_complete', 'mbw_commerce_api_order_complete_handler',5);
if(!function_exists('mbw_commerce_api_order_complete_handler')){
	function mbw_commerce_api_order_complete_handler($billing_id){
		global $mdb;
		$query_data		= mbw_get_vars("op02_update_query");
		if(!empty($query_data)){
			$count					= count($query_data);
			for($i=0;$i<$count;$i++){
				if(!empty($query_data[$i])) $mdb->query($query_data[$i]);
			}
		}
	}
}

//결제 완료시 처리 액션
add_action('mbw_commerce_api_pay_complete', 'mbw_commerce_api_pay_complete_handler',5);
if(!function_exists('mbw_commerce_api_pay_complete_handler')){
	function mbw_commerce_api_pay_complete_handler($billing_id){
	}
}

?>