<?php
$commerce_options											= array();
$commerce_options["post_order_result"]				= "m_order_result";
$commerce_options["post_order_search"]				= "m_order_search";
$commerce_options["post_billing"]						= "m_billing";
$commerce_options["post_product"]						= "m_product";
$commerce_options["post_product_info"]				= "m_product_info";
$commerce_options["post_product_qa"]					= "m_product_qa";
$commerce_options["post_product_review"]			= "m_product_review";
$commerce_options["post_lecture"]						= "m_lecture";
$commerce_options["post_cart"]							= "m_cart";
$commerce_options["post_coupon"]						= "m_coupon";
$commerce_options["post_order"]						= "m_order";
$commerce_options["post_my_order"]					= "m_my_order";
$commerce_options["post_wishlist"]						= "m_wishlist";
$commerce_options["post_point"]						= "m_point";
$commerce_options["post_pay_ts"]						= "m_pay_ts";
$commerce_options["post_pay_pp"]						= "m_pay_pp";

$commerce_options["commerce_pay_log"]				= "false";

//설정값이 존재하지 않을 경우
if(mbw_get_option("commerce_item_type")==""){
	$commerce_options["commerce_item_type"]				= "all";		//전체(all), 가상(virtual), 파일(file), 비디오(video), 배송(단일 배송비,shop) 배송(상품 배송비 open_market)
	$commerce_options["commerce_pay_pg"]					= "inicis";		//inicis, lguplus, kcp
	$commerce_options["commerce_pay_platform"]			= "test";		//test or service
	$commerce_options["commerce_bank_account"]			= "00은행: 0000-000-00000 (예금주: 0000)";
	$commerce_options["use_card_pay"]							= "1";
	$commerce_options["use_d_bank_pay"]						= "1";
	$commerce_options["use_handphone_pay"]				= "1";
	$commerce_options["use_v_bank_pay"]						= "0";
	$commerce_options["use_bank_pay"]						= "1";
	$commerce_options["use_guest_order"]						= "0";
	$commerce_options["use_review_write"]						= "1";
	$commerce_options["use_add_shipping_cost"]				= "1";
	$commerce_options["use_point_pay"]						= "1";
}

$mstore->set_options($commerce_options);

$mb_commerce_image_options							= array();
$mb_commerce_image_options['size']					= "cover";
$mb_commerce_image_options['position']				= "center center";
$mb_commerce_image_options['repeat']					= "no-repeat";

$mb_commerce_virtual_template_type					= array("virtual","file","video","lecture");		//배송이 필요없는 템플릿 타입
$mb_commerce_shipping_cost_template_type			= array("open_market");				//상품 정보에 배송비 표시가 필요한 템플릿 타입
$mb_commerce_sale_status								= array(__MW("W_READY_SALE"),__MW("W_ON_SALE"),__MW("W_SOLD_OUT"),__MW("W_STOP_SALE"),__MW("W_END_SALE"),"가격문의","회원전용");	//순서 변경시 판매중(W_ON_SALE) 항목이 반드시 2번째 위치
$mb_commerce_lecture_status							= array(__MW("W_LECTURE_READY_SALE"),__MW("W_LECTURE_ON_SALE"),__MW("W_LECTURE_SOLD_OUT"),__MW("W_STOP_SALE"),__MW("W_END_SALE"));	//순서 변경시 모집중(W_LECTURE_ON_SALE) 항목이 반드시 2번째 위치

$mb_commerce_pg_method								= array();
$mb_commerce_pg_method["card"]						= __MW("W_PG_METHOD_CARD");
$mb_commerce_pg_method["bank"]						= __MW("W_PG_METHOD_BANK");
$mb_commerce_pg_method["d_bank"]					= __MW("W_PG_METHOD_DBANK");
$mb_commerce_pg_method["handphone"]				= __MW("W_PG_METHOD_HANDPHONE");
$mb_commerce_pg_method["v_bank"]					= __MW("W_PG_METHOD_VBANK");
$mb_commerce_pg_method["point"]						= __MW("W_PG_METHOD_POINT");
$mb_commerce_pg_method["money"]					= "캐시결제";
$mb_commerce_pg_method["auth_bill"]					= "정기결제";
$mb_commerce_pg_method["funding"]					= "클라우드펀딩";
$mb_commerce_pg_method["paypal"]					= "Paypal";
$mb_commerce_pg_method["eximbay"]					= "Eximbay";
$mb_commerce_pg_method["kakaopay"]				= "카카오페이";
$mb_commerce_pg_method["naverpay"]					= "네이버페이";
$mb_commerce_pg_method["samsungpay"]			= "SamsungPay";
$mb_commerce_pg_method["onlykakaopay"]			= "카카오페이";
$mb_commerce_pg_method["onlyssp"]					= "SamsungPay";
$mb_commerce_pg_method["onlypayco"]				= "PAYCO";
$mb_commerce_pg_method["onlylpay"]					= "L.Pay";
$mb_commerce_pg_method["onlyssgcard"]				= "SSG페이";


$mb_commerce_product_type								= array();
$mb_commerce_product_type["shipping"]				= __MW("W_PRODUCT_SHIPPING");
$mb_commerce_product_type["virtual"]					= __MW("W_PRODUCT_VIRTUAL");
$mb_commerce_product_type["file"]						= __MW("W_PRODUCT_FILE");
$mb_commerce_product_type["lecture"]					= __MW("W_PRODUCT_LECTURE");
$mb_commerce_product_type["video"]					= __MW("W_PRODUCT_VIDEO");

$mb_commerce_pay_cancel_state							= array("cancelled_order","completed_refund","cancelled_payment","completed_return");
$mb_commerce_pay_wait_state							= array("completed_order");
$mb_commerce_pay_request_state						= array("return_request","exchange_request","refund_request");
$mb_commerce_pay_complete_state						= array("completed_exchange","completed_payment","completed_payment2","completed_deposit","new_shipping","processing_shipping","shipped","in_transit","completed_shipping","completed_sale");

$mb_commerce_order_state								= array();
$mb_commerce_order_state["completed_order"]		= __MW("W_STATE_COMPLETED_ORDER");
$mb_commerce_order_state["completed_payment"]	= __MW("W_STATE_COMPLETED_DEPOSIT")."/".__MW("W_STATE_COMPLETED_PAYMENT");
//$mb_commerce_order_state["completed_payment2"]	= '주문확인';
//$mb_commerce_order_state["completed_deposit"]	= __MW("W_STATE_COMPLETED_DEPOSIT");
//$mb_commerce_order_state["new_shipping"]			= __MW("W_STATE_NEW_SHIPPING");
$mb_commerce_order_state["processing_shipping"]	= __MW("W_STATE_PROCESSING_SHIPPING");
$mb_commerce_order_state["shipped"]					= __MW("W_STATE_SHIPPED");
$mb_commerce_order_state["completed_shipping"]	= __MW("W_STATE_COMPLETED_SHIPPING");
$mb_commerce_order_state["completed_sale"]			= __MW("W_STATE_COMPLETED_SALE");

$mb_commerce_order_state["cancelled_order"]			= __MW("W_STATE_CANCELLED_ORDER");
$mb_commerce_order_state["return_request"]			= __MW("W_STATE_RETURN_REQUEST");
$mb_commerce_order_state["completed_return"]		= __MW("W_STATE_COMPLETED_RETURN");
$mb_commerce_order_state["exchange_request"]		= __MW("W_STATE_EXCHANGE_REQUEST");
$mb_commerce_order_state["completed_exchange"]	= __MW("W_STATE_COMPLETED_EXCHANGE");
$mb_commerce_order_state["refund_request"]			= __MW("W_STATE_REFUND_REQUEST");
//$mb_commerce_order_state["completed_refund"]	= __MW("W_STATE_COMPLETED_REFUND");
$mb_commerce_order_state["cancelled_payment"]		= __MW("W_STATE_COMPLETED_REFUND")."/".__MW("W_STATE_CANCELLED_PAYMENT");





$mb_commerce_order_completed_state								= array();
$mb_commerce_order_shipping_state								= array();
$mb_commerce_order_virtual_state									= array();
$mb_commerce_order_file_state										= array();
$mb_commerce_order_video_state									= array();
$mb_commerce_order_lecture_state									= array();

$mb_commerce_order_shipping_state["completed_order"]		= __MW("W_STATE_COMPLETED_ORDER");
$mb_commerce_order_shipping_state["completed_payment"]	= __MW("W_STATE_COMPLETED_PAYMENT");
//$mb_commerce_order_shipping_state["completed_payment2"]	= '주문확인';
$mb_commerce_order_shipping_state["processing_shipping"]	= __MW("W_STATE_PROCESSING_SHIPPING");
$mb_commerce_order_shipping_state["shipped"]					= __MW("W_STATE_SHIPPED");
//$mb_commerce_order_shipping_state["in_transit"]					= __MW("W_STATE_SHIPPED");
$mb_commerce_order_shipping_state["completed_shipping"]	= __MW("W_STATE_COMPLETED_SHIPPING");
$mb_commerce_order_shipping_state["completed_sale"]			= __MW("W_STATE_COMPLETED_SALE");
$mb_commerce_order_shipping_state["select-disabled-state"]	= "---------";
$mb_commerce_order_shipping_state["cancelled_order"]			= __MW("W_STATE_CANCELLED_ORDER");
$mb_commerce_order_shipping_state["return_request"]			= __MW("W_STATE_RETURN_REQUEST");
$mb_commerce_order_shipping_state["completed_return"]		= __MW("W_STATE_COMPLETED_RETURN");
$mb_commerce_order_shipping_state["exchange_request"]		= __MW("W_STATE_EXCHANGE_REQUEST");
$mb_commerce_order_shipping_state["completed_exchange"]	= __MW("W_STATE_COMPLETED_EXCHANGE");
$mb_commerce_order_shipping_state["refund_request"]			= __MW("W_STATE_REFUND_REQUEST");
$mb_commerce_order_shipping_state["cancelled_payment"]		= __MW("W_STATE_CANCELLED_PAYMENT");



$mb_commerce_order_virtual_state["completed_order"]			= __MW("W_STATE_COMPLETED_ORDER");
$mb_commerce_order_virtual_state["completed_payment"]		= __MW("W_STATE_COMPLETED_PAYMENT");
$mb_commerce_order_virtual_state["completed_sale"]				= __MW("W_STATE_COMPLETED_SALE");
$mb_commerce_order_virtual_state["cancelled_order"]			= __MW("W_STATE_CANCELLED_ORDER");
$mb_commerce_order_virtual_state["refund_request"]				= __MW("W_STATE_REFUND_REQUEST");
$mb_commerce_order_virtual_state["cancelled_payment"]			= __MW("W_STATE_CANCELLED_PAYMENT");

$mb_commerce_order_file_state											= $mb_commerce_order_virtual_state;
$mb_commerce_order_video_state										= $mb_commerce_order_virtual_state;

$mb_commerce_order_lecture_state["completed_order"]			= __MW("W_STATE_COMPLETED_ORDER");
$mb_commerce_order_lecture_state["completed_payment"]		= __MW("W_STATE_COMPLETED_PAYMENT");
$mb_commerce_order_lecture_state["completed_sale"]			= __MW("W_STATE_COMPLETED_SALE");
$mb_commerce_order_lecture_state["cancelled_order"]			= __MW("W_STATE_CANCELLED_ORDER");
$mb_commerce_order_lecture_state["refund_request"]			= __MW("W_STATE_REFUND_REQUEST");
$mb_commerce_order_lecture_state["cancelled_payment"]		= __MW("W_STATE_CANCELLED_PAYMENT");

if(mbw_get_option("commerce_item_type")=="virtual"){
	$mb_commerce_order_state											= $mb_commerce_order_virtual_state;
}else if(mbw_get_option("commerce_item_type")=="file"){
	$mb_commerce_order_state											= $mb_commerce_order_file_state;
}else if(mbw_get_option("commerce_item_type")=="video"){
	$mb_commerce_order_state											= $mb_commerce_order_video_state;
}else if(mbw_get_option("commerce_item_type")=="lecture"){
	$mb_commerce_order_state											= $mb_commerce_order_lecture_state;
}

$mb_commerce_shipping										= array();
/*
$mb_commerce_shipping["우체국택배"]					= "http://service.epost.go.kr/trace.RetrieveRegiPrclDeliv.postal?sid1=";
$mb_commerce_shipping["CJ대한통운택배"]			= "http://nexs.cjgls.com/web/info.jsp?slipno=";
$mb_commerce_shipping["현대택배"]					= "http://www.hlc.co.kr/hydex/jsp/tracking/trackingViewCus.jsp?InvNo=";
$mb_commerce_shipping["한진택배"]					= "http://www.hanjin.co.kr/Delivery_html/inquiry/result_waybill.jsp?wbl_num=";
$mb_commerce_shipping["로젠택배"]					= "http://d2d.ilogen.com/d2d/delivery/invoice_tracesearch_quick.jsp?slipno=";
$mb_commerce_shipping["동부택배"]					= "http://www.dongbups.com/newHtml/delivery/dvsearch.jsp?mode=SEARCH&search_type=1&sellNum=Y&search_item_no=";
$mb_commerce_shipping["경동택배"]					= "http://kdexp.com/sub3_shipping.asp?stype=1&yy=&mm=&p_item=";
$mb_commerce_shipping["편의점택배"]					= "http://www.doortodoor.co.kr/jsp/cmn/TrackingCVS.jsp?pTdNo=";
$mb_commerce_shipping["옐로우캡"]					= "http://www.yellowcap.co.kr/custom/inquiry_result.asp?invoice_no=";
*/
$mb_commerce_shipping["우체국택배"]					= "https://m.search.daum.net/kakao?w=tot&q=".rawurlencode("우체국택배 ");
$mb_commerce_shipping["CJ대한통운택배"]			= "https://m.search.daum.net/kakao?w=tot&q=".rawurlencode("CJ대한통운택배 ");
$mb_commerce_shipping["현대택배"]					= "https://m.search.daum.net/kakao?w=tot&q=".rawurlencode("현대택배 ");
$mb_commerce_shipping["롯데택배"]					= "https://m.search.daum.net/kakao?w=tot&q=".rawurlencode("롯데택배 ");
$mb_commerce_shipping["한진택배"]					= "https://m.search.daum.net/kakao?w=tot&q=".rawurlencode("한진택배 ");
$mb_commerce_shipping["로젠택배"]					= "https://m.search.daum.net/kakao?w=tot&q=".rawurlencode("로젠택배 ");
$mb_commerce_shipping["동부택배"]					= "https://m.search.daum.net/kakao?w=tot&q=".rawurlencode("동부택배 ");
$mb_commerce_shipping["경동택배"]					= "https://m.search.daum.net/kakao?w=tot&q=".rawurlencode("경동택배 ");
$mb_commerce_shipping["편의점택배"]					= "https://m.search.daum.net/kakao?w=tot&q=".rawurlencode("편의점택배 ");
$mb_commerce_shipping["옐로우캡"]					= "https://m.search.daum.net/kakao?w=tot&q=".rawurlencode("옐로우캡 ");
?>