<?php
if(!function_exists('mbw_get_naver_pay_button')){	
	function mbw_get_naver_pay_button($data=array()) {
		if(intval(mbw_get_option("use_naver_pay"))==3 && strpos(mbw_get_user("fn_user_id"),"test")!==0) return;

		if(empty($data["button_key"])) $data["button_key"]			= trim(mbw_get_option("commerce_naver_pay_button_key"));

		if(mbw_get_vars("device_type")!="desktop"){
			if(!empty($data["mobile_button_type"])) $data["button_type"]		= $data["mobile_button_type"];
			else $data["button_type"]		= "MA";
			if(!empty($data["mobile_color"])) $data["color"]				= $data["mobile_color"];
			else if(empty($data["color"])) $data["color"]							= "1";
			if(!empty($data["mobile_count"])) $data["count"]				= $data["mobile_count"];
			else if(empty($data["count"])) $data["count"]						= "2";
		}else{
			if(empty($data["button_type"])) $data["button_type"]		= "A";
			if(empty($data["color"])) $data["color"]						= "1";
			if(empty($data["count"])) $data["count"]						= "2";
		}

		if(empty($data["buy_handler"])) $data["buy_handler"]		= "buy_nc";
		if(empty($data["wishlist_handler"])) $data["wishlist_handler"]		= "wishlist_nc";

		$script	= "";
		$script	.= '<script type="text/javascript">';
		$script	.= 'naver.NaverPayButton.apply({';
		$script	.= 'BUTTON_KEY: "'.$data["button_key"].'", TYPE: "'.$data["button_type"].'", COLOR: '.$data["color"].', COUNT: '.$data["count"].', ENABLE: "Y",';
		$script	.= 'BUY_BUTTON_HANDLER: '.$data["buy_handler"].',';
		$script	.= 'WISHLIST_BUTTON_HANDLER: '.$data["wishlist_handler"].',';
		$script	.= '"":"" });';
		$script	.= '</script>';
		return $script;
	}
}
if(!function_exists('mbw_make_order_query')){
	function mbw_make_order_query($_id, $_name, $_tprice, $_uprice, $_option, $_count) {
		$ret .= "ITEM_ID=".urlencode($_id);
		$ret .= "&EC_MALL_PID=".urlencode($_id);
		$ret .= "&ITEM_NAME=".urlencode(mbw_htmlspecialchars_decode($_name));
		$ret .= "&ITEM_COUNT=".$_count;

		if(strrpos($_option,'개')!==false){
			$start_index		= strrpos($_option, "개");
			$end_index		= strrpos($_option, "/",$start_index - strlen($_option));
			$temp_name		= (substr($_option,0,$end_index).substr($_option,$start_index+4));
			$_option			= rtrim($temp_name);
		}		
		$ret .= "&ITEM_OPTION=".urlencode($_option);
		$ret .= "&ITEM_TPRICE=".$_tprice;
		$ret .= "&ITEM_UPRICE=".$_uprice;
		return $ret;
	}
}
if(!function_exists('mbw_make_wishlist_query')){
	function mbw_make_wishlist_query($_id, $_name, $_uprice, $_image, $_thumb, $_url) {
		$ret .= "ITEM_ID=".urlencode($_id);
		$ret .= "&EC_MALL_PID=".urlencode($_id);
		$ret .= "&ITEM_NAME=".urlencode(mbw_htmlspecialchars_decode($_name));
		$ret .= "&ITEM_UPRICE=".$_uprice;
		$ret .= "&ITEM_IMAGE=".urlencode(str_replace("https://","http://",$_image));
		$ret .= "&ITEM_THUMB=".urlencode(str_replace("https://","http://",$_thumb));
		$ret .= "&ITEM_URL=".urlencode($_url);
		return $ret;
	}
}
?>