<?php
if(!function_exists('mbw_init_swap_image')){	
	function mbw_init_swap_image(){
		loadScript(MBW_PLUGIN_URL."plugins/swap_image/js/main.js");
	}
}
add_action('wp_enqueue_scripts', 'mbw_init_swap_image');
add_action('admin_enqueue_scripts', 'mbw_init_swap_image');

if(function_exists('mbw_add_template')) mbw_add_template("swapimg","mbw_get_swap_image_template");

if(!function_exists('mbw_get_swap_image_template')){
	function mbw_get_swap_image_template($type, $data){
		global $mdb,$mstore,$mb_languages,$mb_fields;

		$template_start		= "";
		$item_type				= $data["type"];
		
		if($item_type=='swapimg_change'){
			if(!empty($data["value"])){
				$img_url			= "";
				$img_link		= "";
				$img_size		= "";
				$file_name		= "";

				if(!empty($data["size"])) $img_size			= $data["size"];
				if(empty($data["width"])) $data["width"]			= "50px";
				if(empty($data["height"])) $data["height"]		= $data["width"];

				$file_attr					= "";
				if(strpos($data["value"],'http')===0){
					$img_url			= $data["value"];
					$img_link		= $data["value"];
				}else if(mbw_is_image_file($data["value"])){
					
					if(!empty($data["value"])) {
						$file_name		= $data["value"];
						$index1			= strpos($file_name,"_")+1;
						$file_name		= substr($file_name,$index1,strlen($file_name)-$index1);
					}
					$img_link	= mbw_get_image_url("url",$data["value"]);
					if(!empty($img_size)) $img_url		= mbw_get_image_url("url_".$img_size,$data["value"]);
					else $img_url		= mbw_get_image_url("url",$data["value"]);					
				}

				if(!empty($img_url)){
					if(!empty($file_name)){
						if(empty($data["background-size"])) $data["background-size"] = "cover";
						if(empty($data["background-position"])) $data["background-position"] = "center center";
						if(empty($data["background-repeat"])) $data["background-repeat"] = "no-repeat";
						$template_start	= '<div class="mc-gallery-change-img mc-gallery-item-box-padding mc-gallery-change-img-'.mbw_get_board_item("fn_pid").'" style="display:none;position:absolute;top:0;left:0;width:100%;"><div'.$data["ext"].__STYLE("max-width:".$data["width"].";width:".$data["width"].";height:".$data["height"].";margin:0 auto;background-image:url(".$img_url.");background-position:".$data["background-position"].";background-size:".$data["background-size"].";background-repeat:".$data["background-repeat"].";".$data["style"]).' ></div></div>';
					}
				}
			}
		}else if($item_type=='swapimg_hover'){

			if(!empty($data["value"])){
				$img_url			= "";
				$img_link		= "";
				$img_size		= "";
				$file_name		= "";

				if(!empty($data["size"])) $img_size			= $data["size"];
				if(empty($data["width"])) $data["width"]			= "50px";
				if(empty($data["height"])) $data["height"]		= $data["width"];

				$file_attr					= "";
				if(strpos($data["value"],'http')===0){
					$img_url			= $data["value"];
					$img_link		= $data["value"];
				}else if(mbw_is_image_file($data["value"])){					
					if(!empty($data["value"])) {
						$file_name		= $data["value"];
						$index1			= strpos($file_name,"_")+1;
						$file_name		= substr($file_name,$index1,strlen($file_name)-$index1);
					}
					$img_link	= mbw_get_image_url("url",$data["value"]);
					if(!empty($img_size)) $img_url		= mbw_get_image_url("url_".$img_size,$data["value"]);
					else $img_url		= mbw_get_image_url("url",$data["value"]);					
				}

				if(!empty($img_url)){
					if(!empty($file_name)){
						if(empty($data["background-size"])) $data["background-size"] = "cover";
						if(empty($data["background-position"])) $data["background-position"] = "center center";
						if(empty($data["background-repeat"])) $data["background-repeat"] = "no-repeat";
						$template_start	= '<div class="mc-gallery-hover-img mc-gallery-item-box-padding mc-gallery-hover-img-'.mbw_get_board_item("fn_pid").'" style="opacity:0;position:absolute;top:0;left:0;width:100%;"><div'.$data["ext"].__STYLE("max-width:".$data["width"].";width:".$data["width"].";height:".$data["height"].";margin:0 auto;background-image:url(".$img_url.");background-position:".$data["background-position"].";background-size:".$data["background-size"].";background-repeat:".$data["background-repeat"].";".$data["style"]).' ></div></div>';
					}
				}
			}
		}
		return $template_start;		
	}
}
?>
