<?php
if(!function_exists('mbw_user_popup_menu')){
	function mbw_user_popup_menu($menu){
		$user_pid		= mbw_get_param("pid");
		if(!empty($user_pid)){
			if(mbw_is_admin()){
				$admin_url		= admin_url('admin.php');
				$menu[]			= '<a href="'.$admin_url.'?page=mbw_commerce_users&sid='.$user_pid.'" target="_blank"><span>관리자[회원정보]</span></a>';
				$mb_version	= mbw_get_option("mb_version");
				if(version_compare($mb_version, '1.8.5', '<')){
					$search_param		= 'search_field=fn_user_pid&search_text=';
				}else{
					$search_param		= 'suid=';
				}
				if(mbw_get_option("commerce_version")!=""){
					$menu[]	= '<a href="'.$admin_url.'?page=mbw_commerce_order&'.$search_param.$user_pid.'" target="_blank"><span>관리자[주문내역]</span></a>';
					$menu[]	= '<a href="'.$admin_url.'?page=mbw_commerce_point&'.$search_param.$user_pid.'" target="_blank"><span>관리자[포인트로그]</span></a>';
				}
			}
		}
		return $menu;
	}
}
add_filter('mf_user_popup_menu', 'mbw_user_popup_menu',20,1);
?>