<?php
	//반응형 클래스
	if(!empty($args['responsive_class'])) $responsive_class		= $args['responsive_class'];
	else $responsive_class		= "col-421";		//col-543,col-532,col-432,col-421,col-321,col-221,col-111
	if(!empty($args['template'])) $template_name		= $args['template'];
	else $template_name		= "gallery-basic-m6";

	if(!empty($args['height'])) $height						= $args['height'];
	else $height				= "240px";
	if(!empty($args['tablet_height'])) $tablet_height		= $args['tablet_height'];
	else $tablet_height		= "260px";
	if(!empty($args['mobile_height'])) $mobile_height	= $args['mobile_height'];
	else $mobile_height		= "270px";
		
	//갤러리 모델 설정
	$display_check = array('use_img'=>true,'use_swap_img'=>true,'use_hover_img'=>true,'use_title'=>true,'use_desc'=>true,'use_price'=>true,'use_icon1'=>true,'use_icon2'=>true,'use_btn1'=>true,'use_btn2'=>true);
	foreach($display_check as $key=>$value){
		if(!empty($args[$key]) && $args[$key]=="false") $display_check[$key]		= false;
	}
	$gallery_model = "";
	if($display_check['use_img']) $gallery_model .= '{"field":"fn_image_path","name":"이미지","width":"100%","height":"'.$height.'","tablet_height":"'.$tablet_height.'","mobile_height":"'.$mobile_height.'","type":"img_bg","class":"img","size":"small","link":"view","link_url":"vid","td_class":"mc-gallery-item-img-432","search":"false"},';
	if($display_check['use_swap_img']) $gallery_model .= '{"field":"fn_site_link1","name":"Swap Image","width":"100%","height":"'.$height.'","tablet_height":"'.$tablet_height.'","mobile_height":"'.$mobile_height.'","type":"swapimg_change","search":"false","link":"view","link_url":"vid"},';
	if($display_check['use_hover_img']) $gallery_model .= '{"field":"fn_site_link2","name":"Hover Image","width":"100%","height":"'.$height.'","tablet_height":"'.$tablet_height.'","mobile_height":"'.$mobile_height.'","type":"swapimg_hover","search":"false","link":"view","link_url":"vid"},';
	if($display_check['use_btn1']) $gallery_model .= '{"type":"commerce2_btn_hover","name":"구매하기","width":"100%","search":"false"},';
	if($display_check['use_title']) $gallery_model .= '{"field":"fn_title","name":"상품명","width":"","maxlength":"100","maxtext":"..","td_class":"mc-gallery-title","td_style":"padding:11px 10px 4px 13px;","link":"view","link_url":"vid"},';
	if($display_check['use_price']) $gallery_model .= '{"field":"fn_sale_price","name":"가격","width":"","type":"commerce_gallery_price_right","td_class":"mc-gallery-price text-right","td_style":"font-size:13px;height:30px;text-align: left !important;margin-bottom:1px;padding:0 10px 0 14px;","link":"view","link_url":"vid"},';
	if($display_check['use_desc']) $gallery_model .= '{"field":"fn_product_description","name":"상품설명","width":"","type":"commerce_gallery_description","maxlength":"160","maxtext":"..","td_class":"mc-gallery-description","td_style":"","link":"view","link_url":"vid"},';
	if($display_check['use_icon1']) $gallery_model .= '{"field":"fn_product_icon1","type":"commerce_product_add_icon","name":"아이콘","width":"100%","top":"-2px","left":"-5px","img_width":"48px","img_height":"48px","search":"false"},';
	if($display_check['use_icon2']) $gallery_model .= '{"field":"fn_product_icon2","type":"commerce_product_add_icon","name":"아이콘","width":"100%","top":"-2px","left":"45px","img_width":"48px","img_height":"48px","search":"false"},';	

	mbw_set_model("list_gallery",$gallery_model);
	$list_model			= mbw_json_decode(mbw_get_model("list_gallery"));
	$list_data			= mbw_get_list_setup_data($list_model);
	$order_by			= mbw_get_param("order_by");
	$order_type			= mbw_get_param("order_type");

	$select_query		= mbw_get_add_query(array("column"=>"*"), "where", "order")." limit ".$list_data["page_start"].", ".$list_data["page_size"];
	$board_items		= mbw_get_board_items_query($select_query);

?>

<style type="text/css">
	.mb-board .gallery-list-body .mc-gallery-item-style-432 .mc-gallery-item-wrap{padding-bottom:10px;}
	.mb-board .gallery-list-body .mc-gallery-title{font-weight:600;}
	.mb-board .gallery-list-body .mc-gallery-item-style-padding{padding:10px 8px 6px 8px !important}
	.mb-board .gallery-list-body .mc-gallery-description{text-align:left;padding:0 12px 0px 13px !important;min-height:40px;text-overflow:ellipsis;overflow:hidden;display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient: vertical;white-space:normal !important;font-size:13px}

	.mc-gallery-item-wrap .mc-gallery-sale-price1 .mb-number {font-size:18px;}
	.mc-gallery-item-wrap .mc2-btn-hover{opacity:0;transition:opacity 0.35s;}
	.mc-gallery-item-wrap:hover .mc2-btn-hover{opacity:1;transition:opacity 0.35s;}
	.mc-gallery-item-wrap .mc2-btn-hover .cm2-btn-hover-icon:hover{opacity:0.9;transition:opacity 0.35s;}
</style>

<script type="text/javascript">
function selectTabMenu(obj,category,name){
	jQuery('.tab-menu-on').removeClass("tab-menu-on").addClass("tab-menu-off");
	jQuery(obj).removeClass("tab-menu-off").addClass("tab-menu-on");
	sendListTemplateData({"board_name":name,"category":category});
}

function sendSearchData(data){
	var search_url					= mb_urls["search"];	
	var params						= jQuery('#'+mb_options["board_name"]+'_form_board_search').serialize();
	if(typeof(data)!=='undefined') params					= params+"&"+data;
	if(params.indexOf('category')!=-1){
		if(search_url.indexOf('category')!=-1){
			search_url		= search_url.replace(/(category)(\d{1})=/g,"category_old$2=");
		}
	}
	search_url						= search_url+"&"+params;	
	moveURL(search_url);
}


function showDeleteConfirm(){	
	var check_count	= jQuery("input[name='check_array[]']").filter(":checked").length;
	if(check_count > 0) {
		showConfirmPopup(check_count+"<?php echo __MM('MSG_MULTI_DELETE_CONFIRM');?>", {"board_action":"multi_delete"}, sendBoardListData);
	}else{
		showAlertPopup({"code":"1000","message":"<?php echo __MM('MSG_DELETE_SELECT_EMPTY');?>"});
	}
}


function showMoveConfirm(type){	
	var check_count	= jQuery("input[name='check_array[]']").filter(":checked").length;
	if(check_count > 0) {
		if(type=="multi_copy"){
			showConfirmPopup(check_count+"<?php echo __MM('MSG_MULTI_COPY_CONFIRM');?>", {"board_action":type}, sendBoardListData);
		}else if(type=="multi_move"){
			showConfirmPopup(check_count+"<?php echo __MM('MSG_MULTI_MOVE_CONFIRM');?>", {"board_action":type}, sendBoardListData);
		}		
	}else{
		if(type=="multi_copy"){
			showAlertPopup({"code":"1000","message":"<?php echo __MM('MSG_COPY_SELECT_EMPTY');?>"});
		}else if(type=="multi_move"){
			showAlertPopup({"code":"1000","message":"<?php echo __MM('MSG_MOVE_SELECT_EMPTY');?>"});
		}
	}
}

function sendBoardListData(args){	
	if(args.board_action=="multi_modify"){
		document.forms[mb_options["board_name"]+'_form_board_list'].board_pid.value = args.board_pid;
	}

	document.forms[mb_options["board_name"]+'_form_board_list'].board_action.value = args.board_action;
	sendFormDataRequest(jQuery('#'+mb_options["board_name"]+'_form_board_list'), mb_urls["board_api"], sendBoardListDataHandler);
}

function sendBoardListDataHandler(response, state)
{
	if(response.state == "success"){
		if(typeof(response.message)!=='undefined'){
			 if(response.message!="") alert(response.message);
		}
		moveURL("reload");
	}else{			
		showAlertPopup(response);
	}
}
</script>

<div class="mb-style1 gallery-list">
	<form name="<?php echo $mb_board_name;?>_form_board_search" id="<?php echo $mb_board_name;?>_form_board_search" method="post">
	<input type="hidden" name="board_name" value="<?php echo $mb_board_name;?>" />
	<input type="hidden" name="page_id" value="<?php echo mbw_get_param("page_id");?>" />
	<input type="hidden" name="order_by" value="<?php echo $order_by;?>" />
	<input type="hidden" name="order_type" value="<?php echo $order_type;?>" />
	<input type="hidden" name="start_price" id="start_price" value="<?php echo mbw_get_param("start_price");?>" />
	<input type="hidden" name="end_price" id="end_price" value="<?php echo mbw_get_param("end_price");?>" />
	<?php do_action('mbw_board_skin_search'); ?>
	
	<div class="">			
	<?php

		echo '<div class="mb-category-hidden">';			
			echo mbw_get_category_template("hidden");
		echo '</div>';	
	?>
	</div>
	<div class="clear"></div>
	<div class="list-head">
		<?php
			$order_class	= array('fn_product_rank1'=>"",'fn_sale_count'=>"",'fn_review_count'=>"",'fn_sale_price_desc'=>"",'fn_sale_price_asc'=>"",'fn_product_rank1'=>"",'fn_reg_date'=>"");
			if($order_by=="fn_sale_price"){
				$order_class[$order_by."_".$order_type]		= "mc-order-".$order_type;
			}else{
				$order_class[$order_by]				= "mc-order-".$order_type;
			}
		?>	
		<div class="mc-list-order" style="">
			<a href="<?php echo mbw_get_url(array('order_by'=>'fn_product_rank1','order_type'=>"desc")); ?>"><span class="mc-list-order-text <?php echo $order_class["fn_product_rank1"]; ?>">랭킹순</span></a> <span class="mc-list-order-vertical-bar"></span>
			<a href="<?php echo mbw_get_url(array('order_by'=>'fn_sale_count','order_type'=>"desc")); ?>"><span class="mc-list-order-text <?php echo $order_class["fn_sale_count"]; ?>">누적판매순</span></a> <span class="mc-list-order-vertical-bar"></span>
			<a href="<?php echo mbw_get_url(array('order_by'=>'fn_review_count','order_type'=>"desc")); ?>"><span class="mc-list-order-text <?php echo $order_class["fn_review_count"]; ?>">후기많은순</span></a> <span class="mc-list-order-vertical-bar"></span>
			<a href="<?php echo mbw_get_url(array('order_by'=>'fn_sale_price','order_type'=>"asc")); ?>"><span class="mc-list-order-text <?php echo $order_class["fn_sale_price_asc"]; ?>">낮은가격순</span></a> <span class="mc-list-order-vertical-bar"></span>
			<a href="<?php echo mbw_get_url(array('order_by'=>'fn_sale_price','order_type'=>"desc")); ?>"><span class="mc-list-order-text <?php echo $order_class["fn_sale_price_desc"]; ?>">높은가격순</span></a> <span class="mc-list-order-vertical-bar"></span>
			<a href="<?php echo mbw_get_url(array('order_by'=>'fn_reg_date','order_type'=>"desc")); ?>"><span class="mc-list-order-text <?php echo $order_class["fn_reg_date"]; ?>">최신등록순</span></a>
		</div>
		<div class="list-search">
			<select id="search_field" name="search_field" class="search-field margin-right-5" title="<?php echo __MM("W_SEARCH_FIELD");?>"><?php echo $list_data["search"];?></select><input type="text" id="search_text" class="search-text" name="search_text" accesskey="s" title="<?php echo __MM("W_SEARCH_TEXT");?>" value="<?php echo mbw_htmlspecialchars(mbw_get_param("search_text"));?>" onkeypress="checkEnterKey(sendSearchData);"/><input style="display:none !important;" type="text" title="search"/><?php echo mbw_get_btn_template(array("name"=>"Search","onclick"=>"sendSearchData()","class"=>"btn btn-default btn-search margin-left-5")); ?>
		</div>
	</div>
	</form> 	
	<?php do_action('mbw_board_skin_header'); ?>
	<form name="<?php echo $mb_board_name;?>_form_board_list" id="<?php echo $mb_board_name;?>_form_board_list" method="post">	
	<input type="hidden" name="board_name" id="board_name" value="<?php echo $mb_board_name;?>" />
	<input type="hidden" name="page_id" id="page_id" value="<?php echo mbw_get_param("page_id");?>" />
	<input type="hidden" name="list_type" id="list_type" value="<?php echo mbw_get_param("list_type");?>" />
	<input type="hidden" name="page" id="page" value="<?php echo mbw_get_param("page");?>" />
	<input type="hidden" name="mode" id="mode" value="list" />
	<input type="hidden" name="board_action" id="board_action" value="" />
	<input type="hidden" name="board_pid" id="board_pid" value="" />
	<input type="hidden" name="responsive_class" id="responsive_class" value="<?php echo $responsive_class;?>" />
	<input type="hidden" name="template_name" value="<?php echo $template_name;?>" />

	<?php echo mbw_create_nonce("form"); ?>

	<div class="main-style1" id="<?php echo $mb_board_name;?>_board_box">		
		<?php
			echo '<div class="clear"></div><div class="gallery-list-head"></div>';
			echo '<div class="gallery-list-body" id="'.$mb_board_name.'_board_body">';
			if($list_data["total_count"] > 0){
				$load_count		= count($board_items);
				if(!empty($board_items)){
					foreach($board_items as $item){
						mbw_set_board_item($item);
						echo '<div class="mc-gallery-item-style-432 mc-gallery-item-style-padding '.$responsive_class.'" style=""><div class="mc-gallery-item-wrap">';
						foreach($list_model as $data){	
							if(mbw_check_item($data)){
								mbw_get_list_template($data,array("t_td"=>"div"));
							}
						}
						echo '</div></div>';					
					}
				}
			}else{
				echo '<div style="text-align:center;padding:20px !important;">'.__MM("MSG_LIST_ITEM_EMPTY")."</div>";
			}			
			
			echo '</div>';
			echo '<div class="clear"></div><div class="gallery-list-foot"></div>';
			
		?>			
	</div>
	<?php do_action('mbw_board_skin_form'); ?>
	</form>
	<?php do_action('mbw_board_skin_footer'); ?>
	

	<?php
	if(mbw_get_option("use_list_pagination")){
		if($list_data["total_count"] > 0){
			echo '<div id="'.$mb_board_name.'_pagination_box" class="pagination-box">'.mbw_get_pagination_template(array("total_count"=>$list_data["total_count"])).'</div>';
			//AJAX 방식으로 URL 이동없이 페이지 전환하려면 아래 코드 사용
			//echo '<div id="'.$mb_board_name.'_pagination_box" class="pagination-box">'.mbw_get_pagination_template(array("total_count"=>$list_data["total_count"],"page_type"=>"ajax")).'</div>';
		}
	}
	?>
		
</div>