<?php
mbw_set_option("commerce_cart_template", array("cart-basic-1"));

if(!function_exists('mbw_get_commerce_cart_template')){
	function mbw_get_commerce_cart_template($mode,$data){		
		global $mdb,$mstore,$mb_admin_tables,$mb_fields;
		$widget_name			= basename(__FILE__,".php");
		$name					= "commerce_cart";
		$title_max_length		= 30;
		
		if(!empty($data['maxlength'])) $title_max_length		= $data['maxlength'];
		else if($mode=="shortcode") $title_max_length		= 40;

		if(empty($data['list_size'])) $list_size			= "5";
        else $list_size			= mbw_value_filter($data['list_size']);
		if(!empty($data['list_page'])) $list_page	= intval($data['list_page'])-1;
		else $list_page		= 0;
		if($list_page<0) $list_page	= 0;
		if(empty($data['title'])) $title			= "";
        else $title			= $data['title'];

		/*
		if(empty($data['search_field'])) $search_field			= "";
        else $search_field			= mbw_value_filter($data['search_field']);
		if(!isset($data['search_text'])) $search_text			= "";
        else $search_text			= $data['search_text'];
		if(empty($data['category1'])) $category1			= "";
        else $category1			= $data['category1'];
		if(empty($data['category2'])) $category2			= "";
        else $category2			= $data['category2'];
		if(empty($data['category3'])) $category3			= "";
        else $category3			= $data['category3'];
		*/

		if(empty($data['img_width'])) $data['img_width']		= "50px";
		if(empty($data['img_height'])) $data['img_height']		= "50px";
		if(empty($data['template'])) $template			= "cart-basic-543";
        else $template			= $data['template'];

		if(empty($data['class'])) $div_class			= "";
        else $div_class			= ' '.esc_attr($data['class']);
		if(empty($data['style'])) $div_style			= "";
        else $div_style			= " style='".str_replace("'",'"',esc_attr($data['style']))."'";

		$head_title_style1		= "";
		if(!empty($data['head_title_font_size'])){
			if(strpos($data['head_title_font_size'],'px')===false) $data['head_title_font_size']	.= "px";
			$head_title_style1	.= 'font-size:'.mbw_value_filter($data['head_title_font_size']).' !important;';
		}
		if(!empty($data['head_title_font_color'])){
			$data['head_title_font_color']		= mbw_value_filter($data['head_title_font_color'],"color");
			if(strpos($data['head_title_font_color'],'#')!==0 && strpos($data['head_title_font_color'],'rgba(')!==0) $data['head_title_font_color']	= "#".$data['head_title_font_color'];
			$head_title_style1	.= 'color:'.$data['head_title_font_color'].' !important;';
		}
		if(!empty($data['head_title_line_height'])){
			$head_title_style1	.= 'line-height:'.mbw_value_filter($data['head_title_line_height'],"number").' !important;';
		}
		if(!empty($data['head_title_font_weight'])){
			$head_title_style1	.= 'font-weight:'.mbw_value_filter($data['head_title_font_weight']).' !important;';
		}
		if(!empty($head_title_style1)){
			$head_title_style1	= " style='".str_replace("'",'"',esc_attr($head_title_style1))."'";
		}

		$board_field			= $mb_fields[$name];

		global $post;
		if(!empty($data["post_id"])){
			$commerce_permalink		= get_permalink($data["post_id"]);	
		}else if($mode=="shortcode" && !empty($data["target"])){
			$commerce_permalink		= mbw_check_permalink($data["target"]);
		}else if($mode=="shortcode" && !empty($post->ID) && strpos($post->post_content, "[mb_commerce name=") !== false){
			$commerce_permalink		= get_permalink($post->ID);
		}else if(mbw_get_option("commerce_product_view_url")!=""){
			$commerce_permalink		= mbw_get_option("commerce_product_view_url");			
			if(strpos($commerce_permalink, 'http') !== 0 && mbw_check_permalink($commerce_permalink)!="") $commerce_permalink		= mbw_check_permalink($commerce_permalink);
		}else{
			$commerce_permalink		= mbw_check_permalink(mbw_get_option("post_product_info"));
		}	

		if(strpos($commerce_permalink, '?') === false)	$commerce_permalink		= $commerce_permalink."?";
		else 	$commerce_permalink		= $commerce_permalink."&";
		$commerce_permalink		= $commerce_permalink."vid=";
		
		$table_name				= mbw_get_table_name($name);
		$where_query				= ' where '.$board_field["fn_is_order"].'="0"';
		$where_data				= array();		
		/*
		if(!empty($category1)) $where_data[]		= $mdb->prepare($board_field["fn_category1"]."=%s",$category1); 
		if(!empty($category2)) $where_data[]		= $mdb->prepare($board_field["fn_category2"]."=%s",$category2); 
		if(!empty($category3)) $where_data[]		= $mdb->prepare($board_field["fn_category3"]."=%s",$category3); 
		if(!empty($search_field) && $search_text!="") $where_data[] = $mdb->prepare($search_field." like %s","%".$search_text."%");
		if(!empty($where_data)) $where_query				.= " and ".implode(" and ",$where_data);
		*/

		if(mbw_is_login()){
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_user_pid"]."=%s",mbw_get_user("fn_pid"));		
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_cart_id"]."!=%s","");		
		}else{
			$cart_id			= mbw_get_cart_id();			
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_cart_id"]."=%s",$cart_id);		
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_user_pid"]."=%s","0");		
		}		
		$where_query		.= ' and '.$board_field["fn_image_path"].'!=""';
		$cart_list				= $mdb->get_results("SELECT * FROM ".$table_name.$where_query." order by ".mbw_value_filter($board_field["fn_pid"],"name")." DESC limit ".mbw_value_filter($list_page,"int").",".mbw_value_filter($list_size,"int"), ARRAY_A);		
	
		$widget_html	= '<div class="mb-widget">';
		$widget_html	.= '<div'.$div_style.' class="mc-widget-cart mb-widget-'.$mode.$div_class.'">';
		if($mode!="sidebar" && !empty($title)){
			$widget_html	.= '<div class="mc-widget-title"><a href="'.mbw_check_permalink(mbw_get_option("post_cart")).'" title="'.esc_attr($title).'"'.$head_title_style1.'>'.$title.'</a></div>';
		}

		$widget_html	.= '<div class="mc-widget-box">';
		$total_price		= 0;
		if(!empty($cart_list)){
			foreach($cart_list as $cart_item){				
				$add_options			= "";
				$post_title		= mbw_htmlspecialchars_decode($cart_item[$board_field["fn_title"]]);
				if(mb_strlen($post_title)>$title_max_length){
					$post_title		= mb_substr($post_title, 0, $title_max_length)."...";
				}

				$data["size"]		= "&size=middle";
				if(empty($data["background-size"])) $data["background-size"] = "cover";
				if(empty($data["background-position"])) $data["background-position"] = "center center";

				$sale_price		= floatval(apply_filters("mf_product_sale_price",$cart_item[$board_field["fn_sale_price"]],$cart_item[$board_field["fn_product_pid"]]));
				$total_price	= $total_price+($sale_price*floatval($cart_item[$board_field["fn_order_count"]])) + floatval($cart_item[$board_field["fn_order_options_price"]]);
				$sale_price	+= floatval($cart_item[$board_field["fn_order_options_price"]]);
				$widget_html	.= '<div class="mc-widget-item">';

					$widget_html	.= '<div class="mc-product-img"><a href="'.$commerce_permalink.$cart_item[$board_field["fn_product_pid"]].'" title="'.esc_attr($cart_item[$board_field["fn_title"]]).'"><div'.__STYLE("width:".$data["img_width"].";height:".$data["img_height"].";background-image:url(".mbw_get_image_url("url_small",esc_attr($cart_item[$board_field["fn_image_path"]])).");background-position:".$data["background-position"].";background-size:".$data["background-size"].";").' ></div></a></div>';
					$widget_html	.= '<div class="mc-product-text-box">';
					$widget_html	.= '<div class="mc-product-title"><a href="'.$commerce_permalink.$cart_item[$board_field["fn_product_pid"]].'" title="'.esc_attr($cart_item[$board_field["fn_title"]]).'"><span>'.mbw_htmlspecialchars($post_title).'</span></a></div>';

					if(!empty($cart_item[$board_field["fn_order_options"]])) $widget_html	.= '<div>'.mbw_get_htmlpurify(mbw_htmlspecialchars_decode($cart_item[$board_field["fn_order_options"]])).'</div>';
					if(!empty($cart_item[$board_field["fn_order_options1"]])) $add_options.= '<div>'.$cart_item[$board_field["fn_order_options1"]].'</div>';
					if(!empty($cart_item[$board_field["fn_order_options2"]])) $add_options.= '<div>'.$cart_item[$board_field["fn_order_options2"]].'</div>';
					if(!empty($cart_item[$board_field["fn_order_options3"]])) $add_options.= '<div>'.$cart_item[$board_field["fn_order_options3"]].'</div>';
					if(!empty($add_options))  $widget_html	.= '<div class="mc-order-input-options">'.$add_options."</div>";

					$order_price_text		= mbw_set_format($sale_price);
					if(intval($cart_item[$board_field["fn_order_count"]])>1) $order_price_text		.= " x ".mbw_set_format($cart_item[$board_field["fn_order_count"]],"count");

					$widget_html	.= '<div class="mc-product-price"><a href="'.$commerce_permalink.$cart_item[$board_field["fn_product_pid"]].'" title="'.esc_attr($cart_item[$board_field["fn_sale_price"]]).'"><span>'.$order_price_text.'</span></a></div>';
					$widget_html	.= '</div>';
					$widget_html	.= '<div class="clear"></div>';
				$widget_html	.= "</div>";
			}			
		}else{
			$widget_html	.= '<div style="text-align:center;height:45px;">'.__MM("MSG_LIST_PRODUCT_ITEM_EMPTY").'</div>';
		}		

		$widget_html	.= '<div class="mc-cart-total-price-box">';
			$widget_html	.= '<div class="mc-product-total-price">합계: '.mbw_set_format($total_price).'</div>';
			$widget_html	.= '<div class="mc-cart-btn-box"><button onclick="movePage(\''.mbw_check_permalink(mbw_get_option("post_cart")).'\');return false;" class="btn btn-default" title="'.__MW("W_CART").'" type="button"><span>'.__MW("W_CART").'</span></button></div>';

			$widget_html	.= '<div class="clear"></div>';
		$widget_html	.= "</div>";

		$widget_html	.= "</div>";
		$widget_html	.= "</div></div>";
		if(has_filter('mf_widget_html')) $widget_html		= apply_filters("mf_widget_html", $widget_html, $data, $widget_name);
		return $widget_html;
	}
}
?>