<?php
mbw_set_option("commerce_search_template", array("price-basic-1"));
mbw_set_option("commerce_search_template_label", array("가격"));

if(!function_exists('mbw_get_commerce_search_template')){
	function mbw_get_commerce_search_template($mode,$data){		
		global $mdb,$mstore,$mb_admin_tables,$mb_fields;
		$widget_name			= basename(__FILE__,".php");
		$name					= "commerce_product";
		if($mode=="shortcode" && mbw_get_param("mode")=="view") return "";
		else if(mbw_get_board_name()!=$name) return "";

		if(empty($data['title'])) $title			= "";
        else $title			= $data['title'];		

		if(empty($data['template'])) $template			= "tab-basic-1";
        else $template			= $data['template'];		

		if(empty($data['class'])) $div_class			= "";
        else $div_class			= esc_attr($data['class']);
		if(empty($data['style'])) $div_style			= "";
        else $div_style			= " style='".str_replace("'",'"',esc_attr($data['style']))."'";

		$widget_html	= "";
		$widget_html	.= '<div class="mb-widget">';
		$widget_html	.= '<div'.$div_style.' class="mc-widget-search mb-widget-'.$mode.' '.$div_class.'">';

		if($mode!="sidebar" && !empty($title)) 
			$widget_html	.= '<div class="mc-widget-title"><a href="javascript:;" title="'.esc_attr($title).'">'.$title.'</a></div>';

		$widget_html	.= '<div class="mc-widget-box"">';		
			$widget_html	.= '<input type="text" style="text-align:right;width:70px;" class="" name="'.$mode.'_start_price" placeholder="'.__MW("W_CURRENCY").'" value="'.mbw_get_param("start_price").'" /> ~ ';
			$widget_html	.= '<input type="text" style="text-align:right;width:70px;" class="" name="'.$mode.'_end_price" placeholder="'.__MW("W_CURRENCY").'" value="'.mbw_get_param("end_price").'" />';
			$widget_html	.= '<button onclick="sendPriceSearchData(\''.$mode.'\');return false;" class="btn btn-default btn-search margin-left-5" title="'.__MW("W_SEARCH").'" type="button"><span>'.__MW("W_SEARCH").'</span></button>';
		$widget_html	.= '</div>';
		$widget_html	.= '</div>';
		$widget_html	.= '</div>';

		if(has_filter('mf_widget_html')) $widget_html		= apply_filters("mf_widget_html", $widget_html, $data, $widget_name);
		return $widget_html;
	}
}
?>