<?php
//템플릿 함수 등록(템플릿 타입의 접두사, 템플릿 함수명)
if(function_exists('mbw_add_template')) mbw_add_template("commerce2","mbw_get_commerce2_template");

if(!function_exists('mbw_get_commerce2_template')){
	function mbw_get_commerce2_template($mode, $data){
		global $mdb,$mstore,$mb_languages;
		global $mb_commerce_order_state,$mb_commerce_order_shipping_state,$mb_commerce_order_virtual_state,$mb_commerce_order_file_state;
		global $mb_fields,$mb_commerce_shipping,$mb_commerce_pg_method,$mb_commerce_sale_status,$mb_commerce_lecture_status;
		global $mb_table_prefix,$mb_commerce_tables,$mb_admin_tables,$mb_commerce_image_options;
		$template_start		= "";
		$item_type				= $data["type"];
		$commerce_item_state		= array();

		if(strpos($item_type,'commerce2_btn_order')===0){
			$use_product_options	= mbw_get_board_item('fn_use_product_options',false);
			$cart_func		= 'addCart2('.mbw_get_board_item("fn_pid").',this,\'order_count\');';
			if(!empty($use_product_options)){
				$cart_func		= 'checkProductListOptions('.mbw_get_board_item("fn_pid").');';
			}

			$template_start	.= '<div style="padding:8px 13px 10px;">';
				$template_start	.= '<div class="cm-order-count" style="height:32px; border:1px solid #ddd;display: inline-block;vertical-align: top;width: 42.5%;margin-right: 2.5%;"><input name="order_count" class="" maxlength="4" style="border:none;width:100%;max-width:calc(100% - 20px);text-align:left;font-size: 13px;line-height: 1.4;padding:3px 2px 5px 12px;" value="1" type="text"><div class="count-wrap" style="float: right; border-left:1px solid #ddd;"><div class="up cursor_pointer" style="width:15px;height:15px;background-image:url('.MBW_PLUGIN_URL.'templates/commerce/images/icon-up.png);background-position:center center;background-repeat: no-repeat;background-size:50%;border-bottom: 1px solid #ddd;" onclick="setCartCountInput(this,\'plus\',\'order_count\');return false;"></div><div class="down cursor_pointer" style="width:15px;height:15px;background-image:url('.MBW_PLUGIN_URL.'templates/commerce/images/icon-down.png);background-position:center center;background-repeat: no-repeat;background-size:50%;" onclick="setCartCountInput(this,\'minus\',\'order_count\');return false;"></div></div><div class="clear"></div></div>';
				$template_start	.= '<div class="cm-order-cart-btn" onclick="'.$cart_func.'return false;" style="height:32px; border:1px solid #ddd;display: inline-block;font-size: 13px;line-height: 1.4; vertical-align: top;padding-top:6px; width: 55%; text-align:center;cursor: pointer;">장바구니</div>';
			$template_start	.= '</div>'; 
		}else if(strpos($item_type,'commerce2_price_stock')===0){
			
			$product_description		= str_replace(array("\r\n","\n","&nbsp;"," ","  "), " ", strip_tags(mbw_htmlspecialchars_decode(mbw_get_board_item('fn_product_description'))));
			$description_max_length	= 100;
			if(function_exists('mb_strlen') && mb_strlen($product_description, mbw_get_option("encoding"))>$description_max_length){
				$product_description		= mb_substr($product_description, 0, $description_max_length, mbw_get_option("encoding"))."...";
			}
			
			$template_start	.='<div style="padding:5px 7px 2px 7px;">';
				$template_start	.='<div>';
					$template_start	.='<div class="mc-gallery-description">'.$product_description.'</div>';
				$template_start	.='</div>';
				$template_start	.='<div>';
					$template_start	.='<div class="mc-gallery-title" style="float:left;">'.mbw_get_board_item('fn_title').'</div>';
					$template_start	.='<div style="float:right;">댓글 '.mbw_get_board_item('fn_comment_count').'</div>';
					$template_start	.='<div class="clear"></div>';
				$template_start	.='</div>';
				$template_start	.='<div style="padding-bottom:3px;border-bottom:1px solid #EEE;">';
					$event_dday		= mbw_commerce_date_deadline(mbw_get_board_item('fn_lecture_deadline'));
					$template_start	.='<div style="float:left;"><span style="padding:1px 3px;background:#ff8700;color:#fff;border-radius:1px;">'.$event_dday.'</span> 총 수량 <span style="color:#3891f6;font-weight:bold;">'.mbw_get_board_item('fn_lecture_place').'</span>개</div>';
					$template_start	.='<div style="float:right;"><span style="color:rgb(254,67,76);font-weight:bold;">'.number_format(mbw_get_board_item('fn_sale_price')).' 포인트</span></div>';
					$template_start	.='<div class="clear"></div>';
				$template_start	.='</div>';
				$template_start	.='<div style="padding-top:3px;">';
					$template_start	.='<div style="float:left;">1일 1회 응모</div>';
					$template_start	.='<div style="float:right;">'.mbw_get_board_item('fn_sale_count').'회 응모중</div>';
					$template_start	.='<div class="clear"></div>';
				$template_start	.='</div>';
			$template_start	.='</div>';
		}else if(strpos($item_type,'commerce2_btn_hover')===0){
			$use_product_options	= mbw_get_board_item('fn_use_product_options',false);
			$cart_func			= "addCart(".mbw_get_board_item("fn_pid").");";
			$checkout_func		= "addCheckout_direct(".mbw_get_board_item("fn_pid").");";
			if(!empty($use_product_options)){
				$cart_func		= "checkProductListOptions(".mbw_get_board_item("fn_pid").");";
				$checkout_func	= "checkProductListOptions(".mbw_get_board_item("fn_pid").");";
			}
			$template_start	.= '<div class="mc2-btn-hover mb-mobile-hide" style="text-align:center;left: 0;position: absolute;right: 0;bottom: 112px;">';				
				$link_url		= mbw_get_url(array('vid'=>mbw_get_board_item('fn_pid')));
				$template_start	.= '<div class="cm2-btn-hover-icon" title="상세보기" onclick="moveURL(\''.$link_url.'\');return false;" style="text-align: center;width:35px;height:35px;display:inline-block;border:1px solid #ddd;margin-right:-1px;margin-right:-1px;cursor:pointer;background-image:url('.MBW_PLUGIN_URL.'templates/commerce/images/icon-search.png);background-position:center center;background-repeat: no-repeat;background-color:#fff;background-size:65%"><a href="#" style="width:35px;height:35px;"></a></div>';
				$template_start	.= '<div class="cm2-btn-hover-icon" title="장바구니" onclick="'.$cart_func.'return false;" style="text-align: center;width:35px;height:35px;display:inline-block;border:1px solid #ddd;margin-right:-1px;cursor: pointer;background-image:url('.MBW_PLUGIN_URL.'templates/commerce/images/icon-cart.png);background-position:center center;background-repeat: no-repeat;background-color:#fff;background-size:65%"><a href="#" style="width:35px;height:35px;"></a></div>';
				$template_start	.= '<div class="cm2-btn-hover-icon" title="구매하기" onclick="'.$checkout_func.'return false;" style="text-align: center;width:35px;height:35px;display:inline-block;border:1px solid #ddd;margin-right:-1px;cursor: pointer;background-image:url('.MBW_PLUGIN_URL.'templates/commerce/images/icon-card.png);background-position:center center;background-repeat: no-repeat;background-color:#fff;background-size:65%"><a href="#" style="width:35px;height:35px;"></a></div>';
				$template_start	.= '<div class="cm2-btn-hover-icon" title="위시리스트" onclick="addWishlist('.mbw_get_board_item("fn_pid").');return false;" style="text-align: center;width:35px;height:35px;display:inline-block;border:1px solid #ddd;margin-right:-1px;cursor: pointer;background-image:url('.MBW_PLUGIN_URL.'templates/commerce/images/icon-wishlist.png);background-position:center center; background-repeat: no-repeat;background-color:#fff;background-size:65%"><a href="#" style="width:35px;height:35px;" ></a></div>';
			$template_start	.= '</div>'; 
		}else if(strpos($item_type,'commerce2_btn_cart2')===0){
			$use_product_options	= mbw_get_board_item('fn_use_product_options',false);
			$cart_func			= "addCart(".mbw_get_board_item("fn_pid").");";
			$checkout_func		= "addCheckout_direct(".mbw_get_board_item("fn_pid").");";
			if(!empty($use_product_options)){
				$cart_func		= "checkProductListOptions(".mbw_get_board_item("fn_pid").");";
				$checkout_func	= "checkProductListOptions(".mbw_get_board_item("fn_pid").");";
			}
			$template_start	.= '<div class="mc2-bottom-btn-hover" style="padding:11px 2px 8px; border-top:1px solid #ddd; background-color:#F8F8F8;">';
				$template_start	.= '<div class="cm-order-cart" onclick="'.$cart_func.'return false;" style="display: inline-block;font-size: 12px;line-height: 1.4;vertical-align: top;text-align:center;width: 50%;border-right:1px solid #d8d8d8;cursor: pointer;"><div style="display:inline-block;background-image:url('.MBW_PLUGIN_URL.'templates/commerce/images/icon-cart-small.png);background-position:center center;background-repeat: no-repeat; width:16px;height:16px;background-size: cover;vertical-align: middle; margin-right:3px;"></div>장바구니</div>';
				$template_start	.= '<div class="cm-order-direct" onclick="'.$checkout_func.'return false;" style="display: inline-block;font-size: 12px;line-height: 1.4; vertical-align: top; width: 50%; text-align:center;cursor: pointer;"><div style="display:inline-block;background-image:url('.MBW_PLUGIN_URL.'templates/commerce/images/icon-card-small.png);background-position:center center;background-repeat: no-repeat; width:16px;height:16px;background-size: cover;vertical-align: middle; margin-right:3px;"></div>바로구매</div>';
			$template_start	.= '</div>'; 
		}else if(strpos($item_type,'commerce2_gallery_templates_01')===0){
			
			$template_start	.= '<div class="mb-list-title-box">';
				$template_start	.= '<div class="mb-list-title">'.mbw_get_board_item('fn_title').'</div>';
				$template_start	.= '<div class="mb-list-review-count">리뷰 : '.mbw_get_board_item('fn_review_count').'개</div>';				
			$template_start	.= '</div>';

			
		}else if(strpos($item_type,'commerce2_gallery_templates_02')===0){
			
			$template_start	.= '<div class="title-box">';
				$template_start	.= '<div class="title">'.mbw_get_board_item('fn_title').'</div>';
			$template_start	.= '</div>';
			$template_start	.= '<div class="mc-gallery-description">'.mbw_get_board_item('fn_product_description').'</div>';
			$regular_price		= floatval(mbw_get_board_item('fn_regular_price'));
			$sale_price			= floatval(apply_filters("mf_product_sale_price",mbw_get_board_item('fn_sale_price'),mbw_get_board_item('fn_pid'),mbw_get_board_item('fn_category1')));
			if($regular_price!=$sale_price) $template_start	.= '<span class="mc-gallery-regular-price1">'.mbw_set_format($regular_price).'</span>';
			if($sale_price==0) $sale_price_text		= __MW("W_FREE");
				else $sale_price_text	= mbw_set_format($sale_price);
			$template_start	.= '<span class="mc-gallery-sale-price1"> '.$sale_price_text.'</span>';

			$product_type		= mbw_get_board_item('fn_product_type');
			$status				= mbw_get_product_status($product_type);
			if($status!=1){
				$status_text				= mbw_get_product_status_text($product_type,$status);
				if(!empty($status_text)) $template_start	= '<span class="mc-gallery-sale-price1"> '.$status_text.'</span>';				
			}
			$template_start	.= '<div style="position:absolute;left:0; bottom:20px;width:100%;text-align:center;"><img src="'.MBW_PLUGIN_URL.'templates/commerce/images/icon_plus.png" style="width:15px;"></div>';
		}else if(strpos($item_type,'commerce2_gallery_templates_03')===0){
			$template_start	.= '<div>';
				$template_start	.= '<div class="title-box">';
					$template_start	.= '<div class="title">'.mbw_get_board_item('fn_title').'</div>';
				$template_start	.= '</div>';
				$template_start	.= '<div class="mc-gallery-description">'.mbw_get_board_item('fn_product_description').'</div>';
				$regular_price		= floatval(mbw_get_board_item('fn_regular_price'));
				$sale_price			= floatval(apply_filters("mf_product_sale_price",mbw_get_board_item('fn_sale_price'),mbw_get_board_item('fn_pid'),mbw_get_board_item('fn_category1')));
				if($regular_price!=$sale_price) $template_start	.= '<span class="mc-gallery-regular-price1">'.mbw_set_format($regular_price).'</span>';
				if($sale_price==0) $sale_price_text		= __MW("W_FREE");
					else $sale_price_text	= mbw_set_format($sale_price);
				$template_start	.= '<span class="mc-gallery-sale-price1"> '.$sale_price_text.'</span>';

				$product_type		= mbw_get_board_item('fn_product_type');
				$status				= mbw_get_product_status($product_type);
				if($status!=1){
					$status_text				= mbw_get_product_status_text($product_type,$status);
					if(!empty($status_text)) $template_start	= '<span class="mc-gallery-sale-price1"> '.$status_text.'</span>';				
				}
				
			$template_start	.= '</div>';
		}else if(strpos($item_type,'commerce2_gallery_templates_04')===0){
			
			$template_start	.= '<div class="title-box">';
				$template_start	.= '<div class="title">'.mbw_get_board_item('fn_title').'</div>';
				$template_start	.= '<div class="review_count">리뷰 : '.mbw_get_board_item('fn_review_count').'개</div>';
			$template_start	.= '</div>';
			$template_start	.= '<div class="mc-gallery-description">'.mbw_get_board_item('fn_product_description').'</div>';
			$regular_price		= floatval(mbw_get_board_item('fn_regular_price'));
			$sale_price			= floatval(apply_filters("mf_product_sale_price",mbw_get_board_item('fn_sale_price'),mbw_get_board_item('fn_pid'),mbw_get_board_item('fn_category1')));
			if($regular_price!=$sale_price) $template_start	.= '<span class="mc-gallery-regular-price1">'.mbw_set_format($regular_price).'</span>';
			if($sale_price==0) $sale_price_text		= __MW("W_FREE");
				else $sale_price_text	= mbw_set_format($sale_price);
			$template_start	.= '<span class="mc-gallery-sale-price1"> '.$sale_price_text.'</span>';

			$product_type		= mbw_get_board_item('fn_product_type');
			$status				= mbw_get_product_status($product_type);
			if($status!=1){
				$status_text				= mbw_get_product_status_text($product_type,$status);
				if(!empty($status_text)) $template_start	= '<span class="mc-gallery-sale-price1"> '.$status_text.'</span>';				
			}
		}else if(strpos($item_type,'commerce2_gallery_templates_05')===0){
			$template_start	.= '<div>';
				$template_start	.= '<div class="title-box">';
					$template_start	.= '<div class="title">'.mbw_get_board_item('fn_title').'</div>';
				$template_start	.= '</div>';
				$template_start	.= '<div class="price-box">';
					$regular_price		= floatval(mbw_get_board_item('fn_regular_price'));
					$sale_price			= floatval(apply_filters("mf_product_sale_price",mbw_get_board_item('fn_sale_price'),mbw_get_board_item('fn_pid'),mbw_get_board_item('fn_category1')));
					if($regular_price!=$sale_price) $template_start	.= '<div class="mc-gallery-regular-price1">'.mbw_set_format($regular_price).'</div>';
					if($sale_price==0) $sale_price_text		= __MW("W_FREE");
						else $sale_price_text	= mbw_set_format($sale_price);
					$template_start	.= '<div class="mc-gallery-sale-price1"> '.$sale_price_text.'</div>';

					$product_type		= mbw_get_board_item('fn_product_type');
					$status				= mbw_get_product_status($product_type);
					if($status!=1){
						$status_text				= mbw_get_product_status_text($product_type,$status);
						if(!empty($status_text)) $template_start	= '<div class="mc-gallery-sale-price1"> '.$status_text.'</div>';				
					}
				$template_start	.= '</div>';
				$template_start	.= '<div class="mc-gallery-description">'.mbw_get_board_item('fn_product_description').'</div>';
			$template_start	.= '</div>';
		}else if(strpos($item_type,'commerce2_gallery_templates_06')===0){
			$template_start	.= '<div>';
				$template_start	.= '<div class="title-box">';
					$template_start	.= '<div class="title">'.mbw_get_board_item('fn_title').'</div>';
				$template_start	.= '</div>';
				$template_start	.= '<div class="mc-gallery-description">'.mbw_get_board_item('fn_product_description').'</div>';
				$template_start	.= '<div class="price-box">';
					$regular_price		= floatval(mbw_get_board_item('fn_regular_price'));
					$sale_price			= floatval(apply_filters("mf_product_sale_price",mbw_get_board_item('fn_sale_price'),mbw_get_board_item('fn_pid'),mbw_get_board_item('fn_category1')));
					if($regular_price!=$sale_price) $template_start	.= '<span class="mc-gallery-regular-price1">'.mbw_set_format($regular_price).'</span>';
					if($sale_price==0) $sale_price_text		= __MW("W_FREE");
						else $sale_price_text	= mbw_set_format($sale_price);
					$template_start	.= '<span class="mc-gallery-sale-price1"> '.$sale_price_text.'</span>';

					$product_type		= mbw_get_board_item('fn_product_type');
					$status				= mbw_get_product_status($product_type);
					if($status!=1){
						$status_text				= mbw_get_product_status_text($product_type,$status);
						if(!empty($status_text)) $template_start	= '<span class="mc-gallery-sale-price1"> '.$status_text.'</span>';				
					}
				$template_start	.= '</div>';
				
			$template_start	.= '</div>';
		}else if(strpos($item_type,'commerce2_product_add_icon')===0){
			
			$template_start	.='<div class="mc-icons">';
			//fn_product_icon1,fn_product_icon2

			//배송상품이 재고가 없으면 품절 아이콘 표시
			//if(mbw_get_board_item('fn_stock')=="0" && $data["field"]=="fn_product_icon1") $data["value"]		= "no_stock.png";
			//if(empty($data["value"])) return "none";
			//$template_start	.= '<div style="position:absolute;z-index:99000;'.$data["valign"].':'.$data["top"].';'.$data["align"].':'.$data["left"].';"><img src="'.MBW_PLUGIN_URL.'plugins/commerce/icons/'.$data["value"].'"'.$style.'></div>';
				if(!empty(mbw_get_board_item('fn_product_icon1'))){
					$template_start	.= '<div class="mc-icon"><img src="'.MBW_PLUGIN_URL.'plugins/commerce/icons/'.mbw_get_board_item('fn_product_icon1').'"></div>';
				}
				if(!empty(mbw_get_board_item('fn_product_icon2'))){
					$template_start	.= '<div class="mc-icon"><img src="'.MBW_PLUGIN_URL.'plugins/commerce/icons/'.mbw_get_board_item('fn_product_icon2').'"></div>';
				}
				$template_start	.= '<div class="clear"></div>';
			$template_start	.='</div>';

		}else if(strpos($item_type,'commerce2_gallery_img_absolute_box')===0){
			$template_start	.= '<div class="mc2-btn-hover" style="text-align:center;position: absolute;right: 14px;top: 15px;">';
				$template_start	.= '<div class="cm2-btn-hover-icon" onclick="addWishlist('.mbw_get_board_item("fn_pid").');return false;" style="width:34px;height:34px;display:inline-block;border:1px solid #ddd;border-radius:50%;cursor: pointer;background-image:url('.MBW_PLUGIN_URL.'templates/commerce/images/icon-wishlist.png);background-position:center center; background-repeat: no-repeat;background-color:#fff;background-size:68%"></div>';
			$template_start	.= '</div>';
		}else if(strpos($item_type,'commerce2_gallery_img_absolute_box_02')===0){
			$template_start	.= '<div class="mc2-btn-hover" style="text-align:center;position: absolute;right: 14px;top: 15px;">';
				$template_start	.= '<div class="cm2-btn-hover-icon" onclick="addWishlist('.mbw_get_board_item("fn_pid").');return false;" style="width:34px;height:34px;display:inline-block;border:1px solid #ddd;border-radius:50%;cursor: pointer;background-image:url('.MBW_PLUGIN_URL.'templates/commerce/images/icon-wishlist.png);background-position:center center;background-repeat: no-repeat;background-color:#fff;background-size:68%"></div>';
			$template_start	.= '</div>'; 
		}else if(strpos($item_type,'commerce2_talk')===0){
			$template_start	.= '<div>';
				$template_start	.= '<span class="use-navertalk" style="display:inline;"><a href="#" class="navertalk rep-navertalk"><img src="'.MBW_PLUGIN_URL.'templates/commerce/images/btn_mb_navertalk.png" alt="naver talk" style="height:20px;margin-right:5px !important;">궁금할땐 <strong style="color:#fff;">네이버톡톡</strong> 하세요!</a></span>';
				$template_start	.= '<span class="use-kakaotalk" style="display:inline;"><a href="#" class="kakaotalk rep-kakaotalk"><img src="'.MBW_PLUGIN_URL.'templates/commerce/images/btn_mb_kakaotalk.png" alt="kakao talk" style="height:20px;margin-right:5px !important;"><strong>카카오톡 상담</strong> @mangboard</a></span>';
			$template_start	.= '</div>';
		}else if(strpos($item_type,'commerce2_img')===0){
			if(!empty($data["value"])){
				$img_url			= "";
				$img_link		= "";
				$img_size		= "";
				$file_name		= "";

				if(!empty($data["size"])){
					$img_size			= $data["size"];
					$data["size"]		= "&size=".$data["size"];
				} else $data["size"]		= "";
				if(empty($data["width"])) $data["width"]			= "50px";
				if(empty($data["height"])) $data["height"]		= $data["width"];

				$file_attr					= "";
				if(strpos($data["value"],'http')===0){
					$img_url			= $data["value"];
					$img_link		= $data["value"];
				}else if(mbw_is_image_file($data["value"])){
					
					if(!empty($data["value"])) {
						$file_name		= $data["value"];
						$index1			= strpos($file_name,"_")+1;
						$file_name		= substr($file_name,$index1,strlen($file_name)-$index1);
					}
					$img_link	= mbw_get_image_url("url",$data["value"]);
					//$img_url		= mbw_get_image_url("path",$data["value"]).$data["size"];
					if(!empty($img_size)) $img_url		= mbw_get_image_url("url_".$img_size,$data["value"]);
					else $img_url		= mbw_get_image_url("url",$data["value"]);					
				}

				if(!empty($img_url)){
					if(!empty($file_name)){
						if(empty($data["alt"])) $file_attr			= $file_attr.' alt="'.$file_name.'"';
						//if(empty($data["title"])) $file_attr			= $file_attr.' title="'.$file_name.'"';
					}

					if($item_type=='commerce2_img_bg'){						
						$use_product_options	= mbw_get_board_item('fn_use_product_options',false);
						$cart_func			= "addCart(".mbw_get_board_item("fn_pid").");";
						if(!empty($use_product_options)){
							$cart_func		= "checkProductListOptions(".mbw_get_board_item("fn_pid").");";
						}

						if(empty($data["background-size"])) $data["background-size"] = $mb_commerce_image_options['size'];
						if(empty($data["background-position"])) $data["background-position"] = $mb_commerce_image_options['position'];
						if(empty($data["background-repeat"])) $data["background-repeat"] = $mb_commerce_image_options['repeat'];
						$template_start	= '<div class="mc-img-bg-02">';
							$template_start	.= '<div'.$data["ext"].__STYLE("max-width:".$data["width"].";width:".$data["width"].";height:".$data["height"].";margin:0 auto;background-image:url(".$img_url.");background-position:".$data["background-position"].";background-size:".$data["background-size"].";background-repeat:".$data["background-repeat"].";".$data["style"]).' ></div>';
							$template_start	.= '<div class="mc-product-btn-box">';
								$template_start	.= '<div>';
									$template_start	.= '<div class="mc-product-item" onclick="addWishlist('.mbw_get_board_item("fn_pid").');return false;"><img src="'.MBW_PLUGIN_URL.'templates/commerce/images/icon-wishlist.png" alt="wish" style="height:20px;"><div class="item-txt">WISH</div></div>';
									$template_start	.= '<div class="mc-product-item" onclick="'.$cart_func.'return false;"><img src="'.MBW_PLUGIN_URL.'templates/commerce/images/icon_small_my-cart4_mobile.png" alt="wish" style="height:20px;"><div class="item-txt">CART</div></div>';
									$template_start	.= '<div class="mc-product-item"><img src="'.MBW_PLUGIN_URL.'templates/commerce/images/icon_small_search.png" alt="wish" style="height:20px;"><div class="item-txt">PREVIEW</div></div>';
									$template_start	.= '<div class="mc-product-item"><img src="'.MBW_PLUGIN_URL.'templates/commerce/images/icon-wishlist.png" alt="wish" style="height:20px;"><div class="item-txt">OPTION</div></div>';
									$template_start	.= '<div class="clear"></div>';
								$template_start	.= '</div>';
							$template_start	.= '</div>';
						$template_start	.= '</div>';
					}
				}
			}else{
				if(empty($data["width"])) $data["width"]			= "50px";
				if(empty($data["height"])) $data["height"]		= $data["width"];

				$template_start	= '<div'.__STYLE("width:".$data["width"].";height:".$data["height"].";display:table;").' class=""><div style="display:table-cell;vertical-align:middle;">No image</div></div>';
			}
		}		
		return $template_start; 
	}
}
?>